#pragma once
///
/// 㷨
/// 

//#define EIGEN_USE_MKL_ALL
//#define EIGEN_VECTORIZE_SSE4_2
//#include <mkl.h>
// ط

#include <iostream>
#include <Eigen/Core>
#include <Eigen/Dense>
#include <time.h>
#include <boost/filesystem.hpp>
#include <omp.h>
#include "BaseTool.h"
#include "simptsn.h"
#include "SateOrbit.h"
#include <gdal_utils.h>
#include <proj.h>
#include "gdal_priv.h"
#include "gdal_alg.h"
#include <gdal_priv.h>
#include <iostream>
#include <fstream>
#include <QDebug> 
#include <vector>
#include <gdalgrid.h>
#include <boost/filesystem.hpp>
#include "ImageOperatorBase.h"
#include <opencv2/opencv.hpp>



PSTNAlgorithm::PSTNAlgorithm()
{
}

PSTNAlgorithm::PSTNAlgorithm(QString infile_path)
{
	qDebug() << "=========================================================================" ;
	qDebug() << "read  parameters :\t" << infile_path ;
	qDebug() << "parameters files :\t" << infile_path ;
	qDebug() << "params file Format:" ;
	qDebug() << "height --- image height" ;
	qDebug() << "width --- image width" ;
	qDebug() << "R0  --- image nearRange" ;
	qDebug() << "near_in_angle " ;
	qDebug() << "far incident angle " ;
	qDebug() << "LightSpeed " ;
	qDebug() << "lamda" ;
	qDebug() << "imgStartTime" ;
	qDebug() << "PRF" ;
	qDebug() << "refrange" ;
	qDebug() << "fs" ;
	qDebug() << "doppler_paramenter_number " ;
	qDebug() << "doppler_paramenter 1 " ;
	qDebug() << "doppler_paramenter 2" ;
	qDebug() << "doppler_paramenter 3 " ;
	qDebug() << "doppler_paramenter 4 " ;
	qDebug() << "doppler_paramenter 5 " ;
	qDebug() << "ispolySatelliteModel" ;
	qDebug() << "sate polynum " ;
	qDebug() << "SatelliteModelStartTime" ;
	qDebug() << "orbit params list " ;
	qDebug() << "============================================================================" ;

	// ļ
	ifstream infile(infile_path.toUtf8().constData(), ios::in);
	if (!infile.is_open()) {
		throw "ļδ";
	}
	try {
		int line_ids = 0;
		std::string buf;

		// 
		getline(infile, buf); this->height = stoi(buf);
		getline(infile, buf); this->width = stoi(buf);			qDebug() << "height,width\t" << this->height << "," << this->width ;
		getline(infile, buf); this->R0 = stod(buf);				qDebug() << "R0\t" << this->R0 ; //б
		getline(infile, buf); this->near_in_angle = stod(buf);	qDebug() << "near_in_angle\t" << this->R0 ; //
		getline(infile, buf); this->far_in_angle = stod(buf);	qDebug() << "far_in_angle\t" << this->R0 ; //Զ

		getline(infile, buf); this->LightSpeed = stod(buf);		qDebug() << "LightSpeed\t" << this->LightSpeed ;
		getline(infile, buf); this->lamda = stod(buf);			qDebug() << "lamda\t" << this->lamda ;
		getline(infile, buf); this->imgStartTime = stod(buf);	qDebug() << "imgStartTime\t" << this->imgStartTime ;
		getline(infile, buf); this->PRF = stod(buf);			qDebug() << "PRF\t" << this->PRF ;
		getline(infile, buf); this->refrange = stod(buf);		qDebug() << "refrange\t" << this->refrange ;
		getline(infile, buf); this->fs = stod(buf);				qDebug() << "fs\t" << this->fs ;
		this->widthspace = (1 / this->fs) * LIGHTSPEED;
		getline(infile, buf); this->doppler_paramenter_number = stoi(buf); qDebug() << "doppler_paramenter_number\t" << this->doppler_paramenter_number ;

		// ȡϵ
		this->doppler_paras = Eigen::MatrixX<double>(this->doppler_paramenter_number, 1);
		if (this->doppler_paramenter_number > 0) {
			for (int i = 0; i < this->doppler_paramenter_number; i++) {
				getline(infile, buf);
				this->doppler_paras(i, 0) = stod(buf);
			}
			std::cout << "doppler_paramenter:\n" << this->doppler_paras<<std::endl ;
		}
		else {
			throw "ڴ治";
		}
		// ȡǹ
		getline(infile, buf); std::cout << "ispolySatelliteModel\t" << buf ;
		if (stoi(buf) != 1) {
			throw "Ƕʽģ";
		}
		getline(infile, buf); int polynum = stoi(buf) + 1; // ʽ
		getline(infile, buf); double SatelliteModelStartTime = stod(buf); // ģʼʱ

		Eigen::MatrixX<double> polySatellitePara(polynum, 6);
		if (polynum >= 4) {
			for (int i = 0; i < 6; i++) {
				for (int j = 0; j < polynum; j++) {
					getline(infile, buf);
					polySatellitePara(j, i) = stod(buf);
					qDebug() << "orbit params " << i << " , " << j <<QString::fromStdString( buf) ;
				}
			}
		}
		else {
			throw "ڴ治";
		}
		OrbitPoly orbit(polynum, polySatellitePara, SatelliteModelStartTime);
		this->orbit = orbit;
		qDebug() << "sate polynum\t" << polynum ;
		qDebug() << "sate polySatellitePara\n" ;
		for (long i = 0; i < polynum; i++) {
			qDebug() << polySatellitePara(i, 0) << "\t"
				<< polySatellitePara(i, 1) << "\t"
				<< polySatellitePara(i, 2) << "\t"
				<< polySatellitePara(i, 3) << "\t"
				<< polySatellitePara(i, 4) << "\t"
				<< polySatellitePara(i, 5) << "\t";
		}
		qDebug() << "sate SatelliteModelStartTime\t" << SatelliteModelStartTime ;



		if (!infile.eof()) // ȡ任ĺ
		{
			double yy, mm, dd;
			getline(infile, buf);
			if (buf != "" || buf.length() > 3) {
				yy = stod(buf);
				getline(infile, buf); mm = stod(buf);
				getline(infile, buf); dd = stod(buf);
				this->UTC = Eigen::Matrix<double, 1, 3>{ yy,mm,dd };
				std::cout << "UTC\t" << this->UTC << std::endl;
				std::cout << "\nWGS84 to J2000 Params:\t" ;
				getline(infile, buf); this->Xp = stod(buf);		qDebug() << "Xp\t" << this->Xp ;
				getline(infile, buf); this->Yp = stod(buf);		qDebug() << "Yp\t" << this->Yp ;
				getline(infile, buf); this->Dut1 = stod(buf);	qDebug() << "dut1\t" << this->Dut1 ;
				getline(infile, buf); this->Dat = stod(buf);	qDebug() << "dat\t" << this->Dat ;
			}
		}
	}
	catch (exception e) {
		infile.close();
		throw "ļȡ";
	}
	infile.close();
	qDebug() << "============================================================================" ;
}

PSTNAlgorithm::~PSTNAlgorithm()
{
}

/// <summary>
/// demתΪγļ
/// </summary>
/// <param name="dem_path">dem</param>
/// <param name="lon_path"></param>
/// <param name="lat_path">γ</param>
/// <returns></returns>
int PSTNAlgorithm::dem2lat_lon(QString dem_path, QString lon_path, QString lat_path)
{
	gdalImage dem_img(dem_path);
	//gdalImage lon_img = CreategdalImage(lon_path, dem_img.height, dem_img.width);
	//gdalImage lat_img = CreategdalImage(lat_path, dem_img.height, dem_img.width);


	return 0;
}

int PSTNAlgorithm::dem2SAR_RC(QString dem_path, QString sim_rc_path)
{
	return 0;
}


Eigen::MatrixX<double> PSTNAlgorithm::calNumericalDopplerValue(Eigen::MatrixX<double> R)
{
	Eigen::MatrixX<double> t = (R.array() - this->refrange) * (1000000 / LIGHTSPEED);
	Eigen::MatrixX<double> tlist(t.rows(), this->doppler_paramenter_number);// nx5
	tlist.col(0) = Eigen::MatrixX<double>::Ones(t.rows(), 1).col(0);
	for (int i = 1; i < this->doppler_paramenter_number; i++)
	{
		tlist.col(i) = t.array().pow(i);
	}
	//return tlist.array()*this
	return  tlist * this->doppler_paras; //nx5,5x1
	//return Eigen::MatrixX<double>(1, 1);
}


double PSTNAlgorithm::calNumericalDopplerValue(double R)
{
	double t = (R - this->refrange) * (1e6 / LIGHTSPEED);
	return this->doppler_paras(0) + this->doppler_paras(1) * t + this->doppler_paras(2) * t * t + this->doppler_paras(3) * t * t * t + this->doppler_paras(4) * t * t * t * t;
}


Eigen::MatrixX<double> PSTNAlgorithm::PSTN(Eigen::MatrixX<double> landpoints, double ave_dem = 0, double dt = 0.001, bool isCol = false)
{
	//Eigen::MatrixX<double> a(1, 1);
	//a(0, 0) = 1554386455.999999;
	//Eigen::MatrixX<double> satestatetest = this->orbit.SatelliteSpacePoint(a);
	//qDebug() << satestatetest ;

	int point_num = landpoints.rows();
	Eigen::MatrixX<double> SARPoint = Eigen::MatrixX<double>::Ones(point_num, 3);
	double L_T = 0;
	double S_T = 0;
	double R_T = 0;
	double cos_theta = 0;

	Eigen::MatrixX<double> landpoint = Eigen::MatrixX<double>::Ones(1, 6);// ״̬
	Eigen::MatrixX<double> satestate = Eigen::MatrixX<double>::Ones(1, 6);// ״̬
	Eigen::MatrixX<double> satepoint = Eigen::MatrixX<double>::Ones(1, 3);// 
	Eigen::MatrixX<double> satevector = Eigen::MatrixX<double>::Ones(1, 3);// ٶ
	Eigen::MatrixX<double> sate_land = Eigen::MatrixX<double>::Ones(1, 3); // -ʸ
	double ti = this->orbit.SatelliteModelStartTime;
	double R1 = 0;// б
	double R2 = 0;// б
	double FdTheory1 = 0;
	double FdTheory2 = 0;
	double FdNumberical = 0;
	double inc_t = 0;
	double delta_angle = (this->far_in_angle - this->near_in_angle) / this->width;
	//qDebug() << landpoint(0, 0) << "\t" << landpoint(0, 1) << "\t" << landpoint(0, 2) ;
	dt = dt / this->PRF;
	Landpoint satePoints = { 0, 0, 0 };
	Landpoint landPoint = { 0, 0, 0 };
	// ʼ
	for (int j = 0; j < point_num; j++) {
		landpoint = landpoints.row(j);
		for (int i = 0; i < 50; i++) {
			satestate = this->orbit.SatelliteSpacePoint(ti + dt);
			satepoint = satestate(Eigen::all, { 0,1,2 });
			satevector = satestate(Eigen::all, { 3,4,5 });
			sate_land = satepoint - landpoint;
			//qDebug() << sate_land ;
			R1 = (sate_land.array().pow(2).array().rowwise().sum().array().sqrt())[0];;
			FdTheory1 = this->calTheoryDopplerValue(R1, sate_land, satevector);

			satestate = this->orbit.SatelliteSpacePoint(ti);
			satepoint = satestate(Eigen::all, { 0,1,2 });
			satevector = satestate(Eigen::all, { 3,4,5 });
			sate_land = satepoint - landpoint;
			R2 = (sate_land.array().pow(2).array().rowwise().sum().array().sqrt())[0];
			FdNumberical = this->calNumericalDopplerValue(R2);
			FdTheory2 = this->calTheoryDopplerValue(R2, sate_land, satevector);

			inc_t = dt * (FdTheory2 - FdNumberical) / (FdTheory1 - FdTheory2);
			if (abs(FdTheory1 - FdTheory2) < 1e-9) {
				break;
			}
			ti = ti - inc_t;
			if (abs(inc_t) <= dt) {
				break;
			}
		}
		SARPoint(j, 0) = ti;
		SARPoint(j, 1) = (ti - this->imgStartTime) * this->PRF;

		// ʹзк
		satestate = this->orbit.SatelliteSpacePoint(ti);
		satepoint = satestate(Eigen::all, { 0,1,2 });
		sate_land = satepoint - landpoint;
		R1 = (sate_land.array().pow(2).array().rowwise().sum().array().sqrt())[0];;
		SARPoint(j, 2) = getIncAngle(satePoints, landPoint);
		SARPoint(j, 2) = (R1 - this->R0 - (this->refrange - this->R0) / 3) / this->widthspace;
		SARPoint(j, 2) = getRangeColumn(R1, this->R0, this->fs, this->lamda);//    (R1 - this->R0) / this->widthspace; // 
	}
	//qDebug() <<"SARPoints(200, 0):\t" << SARPoint(200, 0) << "\t" << SARPoint(200, 1) << "\t" << SARPoint(200, 2) << "\t" ;
	return SARPoint;
}

/*
Eigen::MatrixXd PSTNAlgorithm::WGS842J2000(Eigen::MatrixXd blh)
{
	return WGS84_J2000::WGS842J2000(blh, this->UTC, this->Xp, this->Yp, this->Dut1, this->Dat);
	//return Eigen::MatrixXd();
}

Landpoint PSTNAlgorithm::WGS842J2000(Landpoint p)
{
	Eigen::MatrixXd blh = Eigen::MatrixXd(1, 3);
	blh<<p.lon, p.lat, p.ati;
	blh=this->WGS842J2000(blh);
	return Landpoint{ blh(0,0),blh(0,1) ,blh(0,0) };
}
*/

/// <summary>
/// ۶վ
/// </summary>
/// <param name="R">б</param>
/// <param name="R_s1">nx3</param>
/// <param name="V_s1">nx3</param>
/// <returns></returns>
Eigen::MatrixX<double> PSTNAlgorithm::calTheoryDopplerValue(Eigen::MatrixX<double> R, Eigen::MatrixX<double> R_s1, Eigen::MatrixX<double> V_s1)
{
	return (R_s1.array() * V_s1.array()).rowwise().sum().array() * (-2) / (R.array() * this->lamda);
	//return Eigen::MatrixX<double>(1, 1);
}

double PSTNAlgorithm::calTheoryDopplerValue(double R, Eigen::MatrixX<double> R_s1, Eigen::MatrixX<double> V_s1) {
	return ((R_s1.array() * V_s1.array()).rowwise().sum().array() * (-2) / (R * this->lamda))[0];
}


simProcess::simProcess()
{

}
simProcess::~simProcess()
{
}
/// <summary>
/// 
/// </summary>
/// <param name="argc"></param>
/// <param name="argv"></param>
/// <returns></returns>
int simProcess::parameters(int argc, char* argv[])
{
	for (int i = 0; i < argc; i++) {
		qDebug() << argv[i] ;
	}
	return 0;
}
/// <summary>
/// Ӷλ,ʼ
/// </summary>
/// <param name="paras_path">ļ·</param>
/// <param name="workspace_path">ռ·</param>
/// <param name="out_dir_path">ռ·</param>
/// <param name="in_dem_path">DEMļ·</param>
/// <param name="in_sar_path">SARӰļ·</param>
/// <returns>ʼu</returns>
int simProcess::InitSimulationSAR(QString paras_path, QString workspace_path, QString out_dir_path, QString in_dem_path, QString in_sar_path)
{

	this->pstn = PSTNAlgorithm(paras_path); // ʼļ
	this->in_dem_path = in_dem_path;
	this->dem_path = JoinPath(workspace_path, "SAR_dem.tiff");// ȡDEM 
	this->workSpace_path = workspace_path;
	this->dem_r_path = JoinPath(workspace_path, "dem_r.tiff");
	
	QString dem_rcs_path = JoinPath(workspace_path, "dem_rcs.tiff");
	this->sar_sim_wgs_path = JoinPath(workspace_path, "sar_sim_wgs.tiff");
	this->sar_sim_path = JoinPath(workspace_path, "sar_sim.tiff");
	this->ori_sim_count_tiff = JoinPath(workspace_path, "RD_ori_sim_count.tiff");
	this->in_sar_path = in_sar_path;
	this->sar_power_path = JoinPath(workspace_path, "in_sar_power.tiff");
	this->outSpace_path = out_dir_path;
	this->out_dem_slantRange_path = out_dir_path + "\\" + "dem_slantRange.tiff";// б
	this->out_plant_slantRange_path = out_dir_path + "\\" + "flat_slantRange.tiff";// ƽб
	this->out_dem_rc_path = out_dir_path + "\\" + "WGS_SAR_map.tiff";// γкӳ


	this->out_incidence_path = out_dir_path + "\\" + "incidentAngle.tiff";// 
	this->out_localIncidenct_path = out_dir_path + "\\" + "localincidentAngle.tiff";// ֵ
	//this->out_ori_sim_tiff = out_dir_path + "\\" + "RD_ori_sim.tif";// 任
	//this->out_sim_ori_tiff = out_dir_path + "\\" + "RD_sim_ori.tif";// 任
	this->dem_rc_path = JoinPath(out_dir_path, "RD_sim_ori.tif");
	this->sar_sim_wgs_path = JoinPath(out_dir_path, "sar_sim_wgs.tiff");
	this->sar_sim_path = JoinPath(out_dir_path, "sar_sim.tiff");


	this->in_rpc_lon_lat_path = this->out_ori_sim_tiff;
	this->out_inc_angle_rpc_path = out_dir_path + "\\" + "RD_incidentAngle.tiff";// ֵ
	this->out_local_inc_angle_rpc_path = out_dir_path + "\\" + "RD_localincidentAngle.tiff";// ֵ
	qDebug() << "==========================================================================" ;
	qDebug() << "in_dem_path" << ":\t" << this->in_dem_path ;
	qDebug() << "in_sar_path" << ":\t" << this->in_sar_path ;
	qDebug() << "workSpace_path" << ":\t" << this->workSpace_path ;
	qDebug() << "dem_path" << ":\t" << this->dem_path ;
	qDebug() << "sar_power_path" << ":\t" << this->sar_power_path ;
	qDebug() << "dem_r_path" << ":\t" << this->dem_r_path ;
	qDebug() << "dem_rc_path" << ":\t" << this->dem_rc_path ;
	qDebug() << "sar_sim_wgs_path" << ":\t" << this->sar_sim_wgs_path ;
	qDebug() << "sar_sim_path" << ":\t" << this->sar_sim_path ;
	qDebug() << "outSpace_path" << ":\t" << this->outSpace_path ;
	qDebug() << "out_dem_slantRange_path" << ":\t" << this->out_dem_slantRange_path ;
	qDebug() << "out_plant_slantRange_path" << ":\t" << this->out_plant_slantRange_path ;
	qDebug() << "out_dem_rc_path" << ":\t" << this->out_dem_rc_path ;
	qDebug() << "out_incidence_path" << ":\t" << this->out_incidence_path ;
	qDebug() << "out_localIncidenct_path" << ":\t" << this->out_localIncidenct_path ;
	qDebug() << "==========================================================================" ;
	this->CreateSARDEM();
	this->dem2SAR_row(); // ȡк
	this->SARIncidentAngle();
	this->SARSimulationWGS();
	this->SARSimulation();
	this->in_sar_power();
	if (boost::filesystem::exists(boost::filesystem::path(this->out_dem_rc_path.toUtf8().constData()))) {
		boost::filesystem::remove(boost::filesystem::path(this->out_dem_rc_path.toUtf8().constData()));
	}
	boost::filesystem::copy_file(boost::filesystem::path(this->dem_rc_path.toUtf8().constData()), boost::filesystem::path(this->out_dem_rc_path.toUtf8().constData()));
	QString sim_rcs_jpg_path = JoinPath(workspace_path, "dem_rcs.jpg");
	QString sar_rcs_jpg_path = JoinPath(workspace_path, "sar_rcs.jpg");
	//this->createimagematchmodel(this->sar_power_path, sar_rcs_jpg_path, this->sar_sim_path, sim_rcs_jpg_path, this->workspace_path);
	//if (this->ismatchmodel) {
	//	qDebug() << "У" ;
	//	this->correctorth_rc(this->dem_rc_path, this->matchmodel);
	//}
	////ֵк
	//this->reflecttable_wgs2range();
	//this->sarincidentangle_rpc();
	return 0;
}
int simProcess::InitASFSAR(QString paras_path, QString workspace_path, QString out_dir_path, QString in_dem_path)
{
	this->pstn = PSTNAlgorithm(paras_path.toUtf8().constData()); // ʼļ
	this->in_dem_path = in_dem_path;
	this->dem_path = JoinPath(workspace_path, "SAR_dem.tiff");// ȡDEM 
	this->workSpace_path = workspace_path;
	this->dem_r_path = JoinPath(workspace_path, "dem_r.tiff");
	this->dem_rc_path = JoinPath(workspace_path, "dem_rc.tiff");
	QString dem_rcs_path = JoinPath(workspace_path, "dem_rcs.tiff");
	this->sar_sim_wgs_path = JoinPath(workspace_path, "sar_sim_wgs.tiff");
	this->sar_sim_path = JoinPath(workspace_path, "sar_sim.tiff");
	this->ori_sim_count_tiff = JoinPath(workspace_path, "RD_ori_sim_count.tiff");
	this->in_sar_path = in_sar_path;
	this->sar_power_path = JoinPath(workspace_path, "in_sar_power.tiff");
	this->outSpace_path = out_dir_path;
	this->out_dem_slantRange_path = out_dir_path + "\\" + "dem_slantRange.tiff";// б
	this->out_plant_slantRange_path = out_dir_path + "\\" + "flat_slantRange.tiff";// ƽб
	this->out_dem_rc_path = out_dir_path + "\\" + "WGS_SAR_map.tiff";// γкӳ
	this->out_incidence_path = out_dir_path + "\\" + "incidentAngle.tiff";// 
	this->out_localIncidenct_path = out_dir_path + "\\" + "localincidentAngle.tiff";// ֵ
	this->out_ori_sim_tiff = out_dir_path + "\\" + "RD_ori_sim.tif";// ֵ
	this->in_rpc_lon_lat_path = this->out_ori_sim_tiff;
	this->out_inc_angle_rpc_path = out_dir_path + "\\" + "RD_incidentAngle.tiff";// ֵ
	this->out_local_inc_angle_rpc_path = out_dir_path + "\\" + "RD_localincidentAngle.tiff";// ֵ
	qDebug() << "==========================================================================" ;
	qDebug() << "in_dem_path" << ":\t" << this->in_dem_path ;
	qDebug() << "in_sar_path" << ":\t" << this->in_sar_path ;
	qDebug() << "workSpace_path" << ":\t" << this->workSpace_path ;
	qDebug() << "dem_path" << ":\t" << this->dem_path ;
	qDebug() << "sar_power_path" << ":\t" << this->sar_power_path ;
	qDebug() << "dem_rc_path" << ":\t" << this->dem_rc_path ;
	qDebug() << "sar_sim_wgs_path" << ":\t" << this->sar_sim_wgs_path ;
	qDebug() << "sar_sim_path" << ":\t" << this->sar_sim_path ;
	qDebug() << "outSpace_path" << ":\t" << this->outSpace_path ;
	qDebug() << "out_dem_slantRange_path" << ":\t" << this->out_dem_slantRange_path ;
	qDebug() << "out_plant_slantRange_path" << ":\t" << this->out_plant_slantRange_path ;
	qDebug() << "out_dem_rc_path" << ":\t" << this->out_dem_rc_path ;
	qDebug() << "out_incidence_path" << ":\t" << this->out_incidence_path ;
	qDebug() << "out_localIncidenct_path" << ":\t" << this->out_localIncidenct_path ;
	qDebug() << "==========================================================================" ;
	this->CreateSARDEM();
	this->dem2SAR_row(); // ȡк
	this->SARIncidentAngle();
	this->SARSimulationWGS();
	ASFOrthClass asfclass;

	this->SARSimulation();
	this->in_sar_power();
	if (boost::filesystem::exists(boost::filesystem::path(this->out_dem_rc_path.toUtf8().constData()))) {
		boost::filesystem::remove(boost::filesystem::path(this->out_dem_rc_path.toUtf8().constData()));
	}
	boost::filesystem::copy_file(boost::filesystem::path(this->dem_rc_path.toUtf8().constData()), boost::filesystem::path(this->out_dem_rc_path.toUtf8().constData()));
	QString sim_rcs_jpg_path = JoinPath(workspace_path, "dem_rcs.jpg");
	QString sar_rcs_jpg_path = JoinPath(workspace_path, "sar_rcs.jpg");
	//this->createImageMatchModel(this->sar_power_path, sar_rcs_jpg_path, this->sar_sim_path, sim_rcs_jpg_path, this->workSpace_path);
	if (this->isMatchModel) {
		qDebug() << "У" ;
		//	this->correctOrth_rc(this->dem_rc_path, this->matchmodel);
	}

	// ֵк
	this->ReflectTable_WGS2Range();
	this->SARIncidentAngle_RPC();
	return 0;
	return 0;
}
/// <summary>
/// SARӦDEM
/// </summary>
/// <returns>ؽ</returns>
int simProcess::CreateSARDEM()
{
	qDebug() << "dem2SAR_Row_col begin time:" << getCurrentTimeString() ;
	{
		gdalImage dem(this->in_dem_path);
		double dem_mean = dem.mean();
		gdalImage sim_rc = CreategdalImage(this->dem_rc_path, dem.height, dem.width, 2, dem.gt, dem.projection);
		DemBox box{ 9999,9999,-9999,-9999 };
		{
			Eigen::MatrixXd sim_r;
			Eigen::MatrixXd sim_c;
			int line_invert = int(2000000 / dem.width);
			line_invert = line_invert > 10 ? line_invert : 10;
			int max_rows_ids = 0;
			int all_count = 0;
			bool state = true;
			omp_lock_t lock;
			omp_init_lock(&lock); // ʼ
#pragma omp parallel for num_threads(8) // NEW ADD
			for (int max_rows_ids = 0; max_rows_ids < dem.height; max_rows_ids = max_rows_ids + line_invert) {
				//line_invert = dem_clip.height - max_rows_ids > line_invert ? line_invert : dem_clip.height - max_rows_ids;

				Eigen::MatrixXd demdata = dem.getData(max_rows_ids, 0, line_invert, dem.width, 1);
				Eigen::MatrixXd sim_r = demdata.array() * 0;
				Eigen::MatrixXd sim_c = demdata.array() * 0;

				int datarows = demdata.rows();
				int datacols = demdata.cols();
				Eigen::MatrixX<double> landpoint(datarows * datacols, 3);
				for (int i = 0; i < datarows; i++) {
					for (int j = 0; j < datacols; j++) {
						landpoint(i * datacols + j, 0) = i + max_rows_ids;
						landpoint(i * datacols + j, 1) = j;
						landpoint(i * datacols + j, 2) = demdata(i, j); // Ϊб࣬ƽΪ0
					}
				}
				//demdata = Eigen::MatrixXd(1, 1);
				landpoint = dem.getLandPoint(landpoint);
				//landpoint.col(2) = landpoint.col(2).array() * 0;

				landpoint = LLA2XYZ(landpoint);
				landpoint = this->pstn.PSTN(landpoint, dem_mean, 0.001, true); // time,r,c
				//qDebug() << "for time " << getCurrentTimeString() ;
				double min_lat = 9999;
				double max_lat = -9999;
				double min_lon = 9999;
				double max_lon = -9999;
				bool has_min_max = false;
				Landpoint p1{ 0,0,0 };
				for (int i = 0; i < datarows; i++) {
					for (int j = 0; j < datacols; j++) {
						sim_r(i, j) = landpoint(i * datacols + j, 1);
						sim_c(i, j) = landpoint(i * datacols + j, 2);
						p1 = dem.getLandPoint(i + max_rows_ids, j, demdata(i, j));
						if (sim_r(i, j) >= 0 && sim_c(i, j) >= 0 && sim_r(i, j) <= this->pstn.height && sim_c(i, j) <= this->pstn.width) {
							min_lat = min_lat < p1.lat ? min_lat : p1.lat;
							max_lat = max_lat > p1.lat ? max_lat : p1.lat;
							min_lon = min_lon < p1.lon ? min_lon : p1.lon;
							max_lon = max_lon > p1.lon ? max_lon : p1.lon;
							has_min_max = true;
						}
					}
				}
				//qDebug() << "for time " << getCurrentTimeString() ;
				// д뵽ļ
				omp_set_lock(&lock); //û
				//qDebug() << "lock" ;
				if (has_min_max) {
					box.min_lat = min_lat < box.min_lat ? min_lat : box.min_lat;
					box.max_lat = max_lat > box.max_lat ? max_lat : box.max_lat;;
					box.min_lon = min_lon < box.min_lon ? min_lon : box.min_lon;;
					box.max_lon = max_lon > box.max_lon ? max_lon : box.max_lon;;
				}
				sim_rc.saveImage(sim_r, max_rows_ids, 0, 1);
				sim_rc.saveImage(sim_c, max_rows_ids, 0, 2);
				all_count = all_count + line_invert;
				qDebug() << "rows:\t" << all_count << "/" << dem.height << "\t computing.....\t" << getCurrentTimeString() ;
				omp_unset_lock(&lock); //ͷŻ
			}
			omp_destroy_lock(&lock); //ٻ
		}

		qDebug() << "prepare over" << getCurrentTimeString() ;
		double dist_lat = box.max_lat - box.min_lat;
		double dist_lon = box.max_lon - box.min_lon;
		dist_lat = 0.2 * dist_lat;
		dist_lon = 0.2 * dist_lon;
		box.min_lat = box.min_lat - dist_lat;
		box.max_lat = box.max_lat + dist_lat;
		box.min_lon = box.min_lon - dist_lon;
		box.max_lon = box.max_lon + dist_lon;

		qDebug() << "box:" ;
		qDebug() << "min_lat-max_lat:\t" << box.min_lat << "\t" << box.max_lat ;
		qDebug() << "min_lon-max_lon:\t" << box.min_lon << "\t" << box.max_lon ;
		qDebug() << "cal box of sar over" ;

		// ֮ӰС
		int width = 1.8 * this->pstn.width;
		int height = 1.8 * this->pstn.height;

		double heightspace = (box.max_lat - box.min_lat) / height;
		double widthspace = (box.max_lon - box.min_lon) / width;
		qDebug() << "resample dem:\n" << getCurrentTimeString() ;
		qDebug() << "in_dem:\t" << this->in_dem_path ;
		qDebug() << "out_dem:\t" << this->dem_path ;
		qDebug() << "width-height:\t" << width << "-" << height ;
		qDebug() << "widthspace\t-\theight\tspace:\t" << widthspace << "\t-\t" << heightspace ;

		int pBandIndex[1] = { 1 };
		int pBandCount[1] = { 1 };

		double gt[6] = {
			box.min_lon,widthspace,0,	 //x
			box.max_lat,0,-heightspace//y
		};

		//boost::filesystem::copy(dem_path, this->dem_path);
		ResampleGDAL(this->in_dem_path.toUtf8().constData(), this->dem_path.toUtf8().constData(), gt, width, height, GRA_Bilinear);

		qDebug() << "resample dem over:\n" << getCurrentTimeString()  ;
		qDebug() << "remove sim_rc_path:\t" << this->dem_rc_path ;
	}

	return 0;
}

/// <summary>
/// ȡк
/// </summary>
/// <returns></returns>
int simProcess::dem2SAR()
{
	qDebug() << "the row  of the sar in dem:" << getCurrentTimeString() ;
	{
		this->dem2SAR_row();
	}

	qDebug() << "the slant range  of the sar in dem:" << getCurrentTimeString()  ;
	{
		gdalImage dem_clip(this->dem_path);
		gdalImage dem_r(this->dem_r_path);
		double dem_mean = dem_clip.mean();
		gdalImage dem_slant_range = CreategdalImage(this->out_dem_slantRange_path, dem_clip.height, dem_clip.width, 1, dem_clip.gt, dem_clip.projection);
		gdalImage plant_slant_range = CreategdalImage(this->out_plant_slantRange_path, dem_clip.height, dem_clip.width, 1, dem_clip.gt, dem_clip.projection);


		int line_invert = int(10000000 / dem_clip.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int count_lines = 0;
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
		qDebug() << "the slant range of the sar:" << getCurrentTimeString() ;
#pragma omp parallel for num_threads(6) // NEW ADD
		for (int max_rows_ids = 0; max_rows_ids < dem_clip.height; max_rows_ids = max_rows_ids + line_invert) {
			Eigen::MatrixXd dem_r_block = dem_r.getData(max_rows_ids, 0, line_invert, dem_clip.width, 1);  // к
			Eigen::MatrixXd demdata = dem_clip.getData(max_rows_ids, 0, line_invert, dem_clip.width, 1); // 
			Eigen::MatrixXd demslant_range = demdata.array() * 0; // б
			int datarows = demdata.rows();
			int datacols = demdata.cols();
			Eigen::MatrixX<double> landpoint(datarows * datacols, 3);
			for (int i = 0; i < datarows; i++) {
				for (int j = 0; j < datacols; j++) {
					landpoint(i * datacols + j, 0) = i + max_rows_ids;
					landpoint(i * datacols + j, 1) = j;
					landpoint(i * datacols + j, 2) = demdata(i, j); // Ϊ0 Ϊʼ0ֵ
				}
			}
			landpoint = dem_clip.getLandPoint(landpoint);
			landpoint = LLA2XYZ(landpoint);// this->pstn.WGS842J2000(landpoint);
			Eigen::MatrixX<double> satestate = Eigen::MatrixX<double>::Ones(1, 6);// ״̬
			Eigen::MatrixX<double> satepoint = Eigen::MatrixX<double>::Ones(1, 3);// 
			long double ti = 0;
			for (int i = 0; i < datarows; i++) {
				for (int j = 0; j < datacols; j++) {
					ti = dem_r_block(i, j) / this->pstn.PRF + this->pstn.imgStartTime;
					satestate = this->pstn.orbit.SatelliteSpacePoint(ti);
					satepoint = satestate(Eigen::all, { 0,1,2 });
					satepoint(0, 0) = satepoint(0, 0) - landpoint(i * datacols + j, 0);
					satepoint(0, 1) = satepoint(0, 1) - landpoint(i * datacols + j, 1);
					satepoint(0, 2) = satepoint(0, 2) - landpoint(i * datacols + j, 2);
					demslant_range(i, j) = (satepoint.array().pow(2).array().rowwise().sum().array().sqrt())[0];
				}
			}
			//qDebug() << "for time " << getCurrentTimeString() ;
			// д뵽ļ
			omp_set_lock(&lock); //û
			dem_slant_range.saveImage(demslant_range, max_rows_ids, 0, 1);
			//sim_rc_reprocess.saveImage(sim_c, max_rows_ids, 0, 2);
			count_lines = count_lines + line_invert;
			qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << dem_clip.height << "\t computing.....\t" << getCurrentTimeString() ;
			omp_unset_lock(&lock); //ͷŻ
		}
		count_lines = 0;
		qDebug() << "the plant slant range of the sar:" << getCurrentTimeString() ;
#pragma omp parallel for num_threads(6) // NEW ADD
		for (int max_rows_ids = 0; max_rows_ids < dem_clip.height; max_rows_ids = max_rows_ids + line_invert) {
			Eigen::MatrixXd dem_r_block = dem_r.getData(max_rows_ids, 0, line_invert, dem_clip.width, 1);  // к
			Eigen::MatrixXd demdata = dem_clip.getData(max_rows_ids, 0, line_invert, dem_clip.width, 1); // 
			Eigen::MatrixXd demslant_range = demdata.array() * 0; // б
			int datarows = demdata.rows();
			int datacols = demdata.cols();
			Eigen::MatrixX<double> landpoint(datarows * datacols, 3);
			for (int i = 0; i < datarows; i++) {
				for (int j = 0; j < datacols; j++) {
					landpoint(i * datacols + j, 0) = i + max_rows_ids;
					landpoint(i * datacols + j, 1) = j;
					landpoint(i * datacols + j, 2) = 0; // Ϊ0 Ϊʼ0ֵ
				}
			}
			landpoint = dem_clip.getLandPoint(landpoint);
			landpoint = LLA2XYZ(landpoint);
			Eigen::MatrixX<double> satestate = Eigen::MatrixX<double>::Ones(1, 6);// ״̬
			Eigen::MatrixX<double> satepoint = Eigen::MatrixX<double>::Ones(1, 3);// 
			long double ti = 0;
			for (int i = 0; i < datarows; i++) {
				for (int j = 0; j < datacols; j++) {
					ti = dem_r_block(i, j) / this->pstn.PRF + this->pstn.imgStartTime;
					satestate = this->pstn.orbit.SatelliteSpacePoint(ti);
					satepoint = satestate(Eigen::all, { 0,1,2 });
					satepoint(0, 0) = satepoint(0, 0) - landpoint(i * datacols + j, 0);
					satepoint(0, 1) = satepoint(0, 1) - landpoint(i * datacols + j, 1);
					satepoint(0, 2) = satepoint(0, 2) - landpoint(i * datacols + j, 2);
					demslant_range(i, j) = (satepoint.array().pow(2).array().rowwise().sum().array().sqrt())[0];
				}
			}
			//qDebug() << "for time " << getCurrentTimeString() ;
			// д뵽ļ
			omp_set_lock(&lock); //û
			plant_slant_range.saveImage(demslant_range, max_rows_ids, 0, 1);
			count_lines = count_lines + line_invert;
			qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << dem_clip.height << "\t computing.....\t" << getCurrentTimeString() ;
			omp_unset_lock(&lock); //ͷŻ
		}
		omp_destroy_lock(&lock); //ٻ
	}
	qDebug() << "the row and col  of the sar in dem:" << getCurrentTimeString() ;
	{
		gdalImage dem_r(this->dem_r_path);
		gdalImage plant_slant_range(this->out_plant_slantRange_path);
		gdalImage dem_rc = CreategdalImage(this->dem_rc_path, dem_r.height, dem_r.width, 2, dem_r.gt, dem_r.projection);

		int line_invert = int(10000000 / dem_r.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int count_lines = 0;
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
		qDebug() << "the row and col  of the sar:" << getCurrentTimeString() ;
#pragma omp parallel for num_threads(6) // NEW ADD
		for (int max_rows_ids = 0; max_rows_ids < dem_r.height; max_rows_ids = max_rows_ids + line_invert) {
			Eigen::MatrixXd dem_r_block = dem_r.getData(max_rows_ids, 0, line_invert, dem_r.width, 1);  // к
			Eigen::MatrixXd slant_range = plant_slant_range.getData(max_rows_ids, 0, line_invert, dem_r.width, 1); // 
			Eigen::MatrixXd dem_c = getRangeColumn(slant_range, this->pstn.R0, this->pstn.fs, this->pstn.lamda);//  (slant_range.array() - this->pstn.R0) / this->pstn.widthspace;
			omp_set_lock(&lock); //û
			dem_rc.saveImage(dem_r_block, max_rows_ids, 0, 1);
			dem_rc.saveImage(dem_c, max_rows_ids, 0, 2);
			count_lines = count_lines + line_invert;
			qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << dem_r.height << "\t computing.....\t" << getCurrentTimeString() ;
			omp_unset_lock(&lock); //ͷŻ
		}
		omp_destroy_lock(&lock); //ٻ
	}


	return 0;
}
/// <summary>
/// صб -- ֵ
/// </summary>
/// <returns></returns>
int simProcess::SARIncidentAngle()
{
	qDebug() << "the incidence angle  and local incidence :" << getCurrentTimeString() ;
	{
		gdalImage dem_img(this->dem_path);
		gdalImage sim_r_img(this->dem_r_path);
		gdalImage localincidence_angle_img = CreategdalImage(this->out_localIncidenct_path, dem_img.height, dem_img.width, 1, dem_img.gt, dem_img.projection);// עﱣ
		gdalImage incidence_angle_img = CreategdalImage(this->out_incidence_path, dem_img.height, dem_img.width, 1, dem_img.gt, dem_img.projection);// עﱣ
		incidence_angle_img.setNoDataValue(-10, 1);
		localincidence_angle_img.setNoDataValue(-10, 1);
		double PRF = this->pstn.PRF;
		double imgstarttime = this->pstn.imgStartTime;
		int line_invert = int(5000000 / dem_img.width);// С
		line_invert = line_invert > 100 ? line_invert : 100;
		int start_ids = 0; // ʾ1
		int line_width = dem_img.width;
		int count_lines = 0;
		for (int max_rows_ids = 0; max_rows_ids < dem_img.height; max_rows_ids = max_rows_ids + line_invert) {
			Eigen::MatrixXd sim_inclocal = incidence_angle_img.getData(max_rows_ids, 0, line_invert + 2, line_width, 1);
			Eigen::MatrixXd sim_localinclocal = localincidence_angle_img.getData(max_rows_ids, 0, line_invert + 2, line_width, 1);
			sim_inclocal = sim_inclocal.array() * 0 - 10;
			sim_localinclocal = sim_localinclocal.array() * 0 - 10;
			localincidence_angle_img.saveImage(sim_localinclocal, max_rows_ids, 0, 1);
			incidence_angle_img.saveImage(sim_inclocal, max_rows_ids, 0, 1);
		}

		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
		line_invert = int(200000000 / dem_img.width);// С
		for (int max_rows_ids = 1; max_rows_ids < dem_img.height; max_rows_ids = max_rows_ids + line_invert) {
			start_ids = max_rows_ids - 1;
			Eigen::MatrixXd demdata = dem_img.getData(max_rows_ids - 1, 0, line_invert + 2, line_width, 1);
			Eigen::MatrixXd sim_r = sim_r_img.getData(max_rows_ids - 1, 0, line_invert + 2, line_width, 1).cast<double>(); //
			Eigen::MatrixXd sim_inclocal = incidence_angle_img.getData(max_rows_ids - 1, 0, line_invert + 2, line_width, 1);
			Eigen::MatrixXd sim_localinclocal = localincidence_angle_img.getData(max_rows_ids - 1, 0, line_invert + 2, line_width, 1);
			//sim_r = sim_r.array() * (1 / PRF) + imgstarttime;
			int rowcount = demdata.rows();
			int colcount = demdata.cols();
#pragma omp parallel for num_threads(8) // NEW ADD
			for (int i = 1; i < rowcount - 1; i++) {
				
				// sataState = 
				Landpoint p0, p1, p2, p3, p4, slopeVector, landpoint, satepoint;
				long double r;
				for (int j = 1; j < colcount - 1; j++) {
					r = sim_r(i, j);
					Eigen::MatrixX<double> sataState = this->pstn.orbit.SatelliteSpacePoint(r / PRF + imgstarttime);
					p0 = dem_img.getLandPoint(i + start_ids, j, demdata(i, j)); // 
					p1 = dem_img.getLandPoint(i + start_ids - 1, j, demdata(i - 1, j)); // 1 
					p2 = dem_img.getLandPoint(i + start_ids, j + 1, demdata(i, j + 1)); // 2
					p3 = dem_img.getLandPoint(i + start_ids + 1, j, demdata(i + 1, j)); // 3
					p4 = dem_img.getLandPoint(i + start_ids, j - 1, demdata(i, j - 1)); // 4
					slopeVector = getSlopeVector(p0, p1, p2, p3, p4);
					landpoint = LLA2XYZ(p0);
					satepoint = Landpoint{ sataState(0,0),sataState(0,1) ,sataState(0,2) };
					sim_localinclocal(i, j) = getlocalIncAngle(satepoint, landpoint, slopeVector);
					//p0.ati = 0;
					p0 = dem_img.getLandPoint(i + start_ids, j, demdata(i, j)); // 
					landpoint = LLA2XYZ(p0);
					sim_inclocal(i, j) = getIncAngle(satepoint, landpoint);
				}
			}
			int rows_save = sim_inclocal.rows() - 2;
			//sim_inclocal =.array();
			//sim_localinclocal = .array();
			omp_set_lock(&lock); //û
			count_lines = count_lines + line_invert;
			Eigen::MatrixXd sim_localinclocalblock = sim_localinclocal.block(1, 0, rows_save, line_width).array();
			Eigen::MatrixXd sim_inclocalblock = sim_inclocal.block(1, 0, rows_save, line_width).array();
			localincidence_angle_img.saveImage(sim_localinclocalblock, max_rows_ids, 0, 1);
			incidence_angle_img.saveImage(sim_inclocalblock, max_rows_ids, 0, 1);
			qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << dem_img.height << "\t computing.....\t" << getCurrentTimeString() ;
			omp_unset_lock(&lock); //ͷŻ
		}
		omp_destroy_lock(&lock); //ٻ
	}
	qDebug() << "the incidence angle  and local incidence over:\t" << getCurrentTimeString() ;
	return 0;
}
/// <summary>
/// ģWGS SARֵ
/// </summary>
/// <returns></returns>
int simProcess::SARSimulationWGS()
{
	qDebug() << "computer the simulation value of evering dem meta,      begining:\t" << getCurrentTimeString() ;
	gdalImage localincidence_angle_img(this->out_localIncidenct_path);
	gdalImage sim_sar_img = CreategdalImage(this->sar_sim_wgs_path, localincidence_angle_img.height, localincidence_angle_img.width, 1, localincidence_angle_img.gt, localincidence_angle_img.projection);// עﱣ
	int line_invert = int(5000000 / localincidence_angle_img.width);// С
	line_invert = line_invert > 100 ? line_invert : 100;
	int start_ids = 0; // ʾ1
	int line_width = localincidence_angle_img.width;
	int count_lines = 0;
	omp_lock_t lock;
	omp_init_lock(&lock); // ʼ
#pragma omp parallel for num_threads(6) // NEW ADD
	for (int max_rows_ids = 0; max_rows_ids < sim_sar_img.height; max_rows_ids = max_rows_ids + line_invert) {
		Eigen::MatrixXd sim_localinclocal = localincidence_angle_img.getData(max_rows_ids, 0, line_invert, line_width, 1);
		Eigen::MatrixXd sim_sar(line_invert, line_width);
		sim_localinclocal = sim_localinclocal.array() * d2r;
		// double((0.0133 * cos(localincangle) / pow(sin(localincangle + 0.1 * localincangle), 3)));
		Eigen::MatrixXd cos_angle = sim_localinclocal.array().cos();
		Eigen::MatrixXd sin_angle = sim_localinclocal.array().sin();
		sim_sar = (0.0133 * cos_angle.array()) / ((sin_angle.array() + 0.1 * cos_angle.array()).pow(3));
		omp_set_lock(&lock); //û
		count_lines = count_lines + line_invert;
		sim_sar_img.saveImage(sim_sar, max_rows_ids, 0, 1);
		qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << sim_sar_img.height << "\t computing.....\t" << getCurrentTimeString() ;
		omp_unset_lock(&lock); //ͷŻ
	}
	omp_destroy_lock(&lock); //ٻ
	qDebug() << "computer the simulation value of evering dem meta,      begining:\t" << getCurrentTimeString() ;

	return 0;
}

int simProcess::SARSimulation()
{
	qDebug() << "computer the simulation value of sim_sar,      begining:\t" << getCurrentTimeString() ;
	gdalImage sim_sar_wgs_img(this->sar_sim_wgs_path);
	gdalImage sim_rc(this->dem_rc_path);
	gdalImage localIncident_img(this->out_localIncidenct_path);
	gdalImage sim_sar_img = CreategdalImage(this->sar_sim_path, this->pstn.height, this->pstn.width, 1, sim_sar_wgs_img.gt, sim_sar_wgs_img.projection, false);// עﱣ
	{
		sim_sar_img.setNoDataValue(-9999, 1);
		//double PRF = this->pstn.PRF;
		//double imgstarttime = this->pstn.imgStartTime;
		int line_invert = int(30000000 / sim_sar_wgs_img.width);// С
		line_invert = line_invert > 100 ? line_invert : 100;
		int start_ids = 0; // ʾ1
		int line_width = sim_sar_wgs_img.width;
		Eigen::MatrixXd sim_r(line_invert, line_width);
		Eigen::MatrixXd sim_c(line_invert, line_width);
		Eigen::MatrixXd sim_sum_h(line_invert, line_width);
		Eigen::MatrixXd sim_rsc_orth(line_invert, line_width);
		Eigen::MatrixXd sim_sum_sar(line_invert, line_width);
		Eigen::MatrixXd demdata(line_invert, line_width);
		Eigen::MatrixXd angle(line_invert, line_width);

		// ʼ
		do {
			sim_sum_sar = sim_sar_img.getData(start_ids, 0, line_invert, this->pstn.width, 1).cast<double>();
			sim_sum_sar = sim_sum_sar.array() * 0;
			sim_sar_img.saveImage(sim_sum_sar, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);
		{
			// ۼӼģֵ
			int rowcount = 0, colcount = 0;
			int row_min = 0, row_max = 0;
			start_ids = 0;
			qDebug() << "time:\tsim_arr_row_min\tsim_arr_row_max\tsim_arr_all_lines\tsim_row_min\tsim_row_max\tsim_row_min0\tsim_row_max0" ;;
			do {
				qDebug() << "\n" << getCurrentTimeString() << "\t" << start_ids << "\t" << start_ids + line_invert << "\t" << sim_rc.height << "\t";
				sim_r = sim_rc.getData(start_ids, 0, line_invert, line_width, 1).cast<double>(); // 
				sim_c = sim_rc.getData(start_ids, 0, line_invert, line_width, 2).cast<double>(); // 
				angle = localIncident_img.getData(start_ids, 0, line_invert, line_width, 1).cast<double>();
				sim_rsc_orth = sim_sar_wgs_img.getData(start_ids, 0, line_invert, line_width, 1).cast<double>(); // ֵ
				// Χ
				row_min = (floor(sim_r.minCoeff()));
				row_max = (ceil(sim_r.maxCoeff()));
				qDebug() << row_min << "\t" << row_max << "\t";

				//qDebug() << "line range:\t" << row_min << " - " << row_max  << "\t computing.....\t" << getCurrentTimeString() ;

				if (row_max < 0 || row_min>this->pstn.height) {
					start_ids = start_ids + line_invert;
					continue;
				}
				row_min = row_min <= 0 ? 0 : row_min;
				row_max = row_max >= this->pstn.height ? this->pstn.height : row_max;
				qDebug() << row_min << "\t" << row_max ;
				//sim_sum_sar =sim_sar.getData(row_min, 0, row_max-row_min+1, this->pstn.width, 1).cast<double>();
				//sim_sum_count = sim_sar.getData(row_min, 0, row_max - row_min + 1, this->pstn.width, 2).cast<double>();
				if (row_min >= row_max) {
					break;
				}
				sim_sum_sar = sim_sar_img.getData(row_min, 0, row_max - row_min + 1, this->pstn.width, 1).cast<double>();
				rowcount = sim_r.rows();
				colcount = sim_r.cols();

#pragma omp parallel for num_threads(4) // NEW ADD
				for (int i = 0; i < rowcount; i++) {
					int row_ids = 0, col_ids = 0;
					for (int j = 0; j < colcount; j++) {
						row_ids = int(round(sim_r(i, j)));
						col_ids = int(round(sim_c(i, j)));
						if (row_ids >= 0 && row_ids < this->pstn.height && col_ids >= 0 && col_ids < this->pstn.width && (angle(i, j) < 90 || angle(i, j) > 270)) {
							sim_sum_sar(row_ids - row_min, col_ids) += sim_rsc_orth(i, j);
						}
					}
				}
				sim_sar_img.saveImage(sim_sum_sar, row_min, 0, 1);

				start_ids = start_ids + line_invert;
			} while (start_ids < sim_rc.height);
			qDebug() << "\ncomputer the simulation value of sim_sar,    overing  :\t" << getCurrentTimeString() ;
		}
	}

	{
		qDebug() << "Resample simulation value of sim_sar :\t" << getCurrentTimeString() ;
		ResampleGDALs(this->sar_sim_path.toUtf8().constData(), 1, GRIORA_Bilinear);
	}

	return 0;
}

int simProcess::in_sar_power()
{
	qDebug() << "compute the power value of ori sar, beiging:\t" << getCurrentTimeString() ;
	gdalImage ori_sar(this->in_sar_path);
	gdalImage sim_power = CreategdalImage(this->sar_power_path, ori_sar.height, ori_sar.width, 1, ori_sar.gt, ori_sar.projection);
	sim_power.setNoDataValue(-9999, 1);
	{
		Eigen::MatrixXd band1(1, 1);
		Eigen::MatrixXd band2(1, 1);
		Eigen::MatrixXd power_value(1, 1);
		int start_ids = 0;
		int line_invert = int(8000000 / ori_sar.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int row_count = 0, col_count = 0;
		do {
			qDebug() << "rows:\t" << start_ids << "/" << ori_sar.height << "\t computing.....\t" << getCurrentTimeString() ;
			band1 = ori_sar.getData(start_ids, 0, line_invert, ori_sar.width, 1).cast<double>(); // a
			band2 = ori_sar.getData(start_ids, 0, line_invert, ori_sar.width, 2).cast<double>(); // b
			power_value = (band1.array().pow(2) + band2.array().pow(2) + 1).log10() * 10;// 10 * Eigen::log10(Eigen::pow(0.5, Eigen::pow(2, band1.array()) + Eigen::pow(2, band2.array()))).array();
			sim_power.saveImage(power_value, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < ori_sar.height);
	}
	{
		qDebug() << "Resample the power value of ori sar :\t" << getCurrentTimeString() ;
		ResampleGDALs(this->sar_power_path.toUtf8().constData(), 1, GRIORA_Bilinear);
	}
	qDebug() << "compute the power value of ori sar, ending:\t" << getCurrentTimeString() ;
	{
		qDebug() << "=========================================\n";
		qDebug() << " the power image of  sar  :\n";
		qDebug() << this->sar_power_path.toUtf8().constData() << "\n";
		qDebug() << "band 1 : power value   \t  10*log10(b1^2+b2^2)   \n";
		qDebug() << "=========================================\n";

	}
	return 0;
	return 0;
}




int simProcess::Scatter2Grid(QString lon_lat_path, QString data_tiff, QString grid_path, double space) {

	gdalImage lon_lat_img(lon_lat_path);
	double min_lon = 400, max_lon = -400, min_lat = 300, max_lat = -300;
	{
		int conver_lines = 2000;
		for (int max_rows_ids = 0; max_rows_ids < lon_lat_img.height; max_rows_ids = max_rows_ids + conver_lines) {
			Eigen::MatrixXd lon = lon_lat_img.getData(max_rows_ids, 0, conver_lines, lon_lat_img.width, 1);
			Eigen::MatrixXd lat = lon_lat_img.getData(max_rows_ids, 0, conver_lines, lon_lat_img.width, 2);
			int rows = lon.rows();
			int cols = lon.cols();
			for (int i = 0; i < rows; i++) {
				for (int j = 0; j < cols; j++) {
					if (min_lon > lon(i, j) && !isnan(lon(i, j)) && lon(i, j) > -200) {
						min_lon = lon(i, j);
					}
					if (min_lat > lat(i, j) && !isnan(lat(i, j)) && lat(i, j) > -200) {
						min_lat = lat(i, j);
					}
					if (max_lon < lon(i, j) && !isnan(lon(i, j)) && lon(i, j) > -200) {
						max_lon = lon(i, j);
					}

					if (max_lat < lat(i, j) && !isnan(lat(i, j)) && lat(i, j) > -200) {
						max_lat = lat(i, j);
					}
				}
			}
		}
	}
	qDebug() << "lon:\t" << min_lon << " , " << max_lon ;
	qDebug() << "lat:\t" << min_lat << " , " << max_lat ;

	double delta = space /( 110 * 1000);
	int width = int((max_lon - min_lon) / delta) + 1;
	int height = int((max_lat - min_lat) / delta) + 1;
	Eigen::MatrixXd gt(2, 3);
	gt(0, 0) = min_lon; gt(0, 1) = delta; gt(0, 2) = 0;//x
	gt(1, 0) = max_lat; gt(1, 1) = 0; gt(1, 2) = -1*delta;//y

	// # 
	char* pszSrcWKT = NULL;
	OGRSpatialReference oSRS;
	oSRS.importFromEPSG(4326);
	//oSRS.SetUTM(50, true);   //  120  
	//oSRS.SetWellKnownGeogCS("WGS84");
	oSRS.exportToWkt(&pszSrcWKT);
	gdalImage grid_img = CreategdalImage(grid_path, height, width, 1, gt, pszSrcWKT, true);
	int conver_lines = 2000;
	for (int max_rows_ids = 0; max_rows_ids < grid_img.height; max_rows_ids = max_rows_ids + conver_lines) {
		Eigen::MatrixXd grid_data = grid_img.getData(max_rows_ids, 0, conver_lines, width, 1);
		grid_data = grid_data.array() * 0 - 9999;
		grid_img.saveImage(grid_data, max_rows_ids, 0, 1);
	}
	grid_img.setNoDataValue(-9999, 1);
	Eigen::MatrixXd grid_data = grid_img.getData(0, 0, grid_img.height, grid_img.width, 1);
	gdalImage Range_data(data_tiff);
	grid_img.InitInv_gt();
	{
		int conver_lines = 500;
		int line_invert = 400;// ص
		int line_offset = 60;
		// 
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
		int allCount = 0;
	
		for (int max_rows_ids = 0; max_rows_ids < lon_lat_img.height; max_rows_ids = max_rows_ids + line_invert) {
			Eigen::MatrixXd lon_data = lon_lat_img.getData(max_rows_ids, 0, conver_lines, lon_lat_img.width, 1);
			Eigen::MatrixXd lat_data = lon_lat_img.getData(max_rows_ids, 0, conver_lines, lon_lat_img.width, 2);
			Eigen::MatrixXd data = Range_data.getData(max_rows_ids, 0, conver_lines, lon_lat_img.width, 1);
			int lon_row_count = lon_data.rows();
			for (int i = 0; i < lon_row_count; i++) {
				for (int j = 0; j < lon_lat_img.width; j++) {
					Landpoint p = grid_img.getRow_Col(lon_data(i, j), lat_data(i, j));
					lon_data(i, j) = p.lon;
					lat_data(i, j) = p.lat;
				}
			}
			int dem_rows_num = lon_data.rows();
			int dem_cols_num = lon_data.cols();

			#pragma omp parallel for num_threads(8) // NEW ADD
			for (int i = 0; i < dem_rows_num - 1; i++) {
				for (int j = 0; j < dem_cols_num - 1; j++) {
					Point3 p, p1, p2, p3, p4;

					p1 = { lat_data(i,j),lon_data(i,j) };
					p2 = { lat_data(i,j + 1),lon_data(i,j + 1) };
					p3 = { lat_data(i + 1, j + 1),lon_data(i + 1, j + 1) };
					p4 = { lat_data(i + 1, j),lon_data(i + 1, j) };

					//if (angle(i, j) >= 90 && angle(i, j + 1) >= 90 && angle(i + 1, j) >= 90 && angle(i + 1, j + 1) >= 90) {
					//	continue;
					//}

					double temp_min_r = lat_data.block(i, j, 2, 2).minCoeff();
					double temp_max_r = lat_data.block(i, j, 2, 2).maxCoeff();
					double temp_min_c = lon_data.block(i, j, 2, 2).minCoeff();
					double temp_max_c = lon_data.block(i, j, 2, 2).maxCoeff();
					if ((int(temp_min_r) != int(temp_max_r)) && (int(temp_min_c) != int(temp_max_c))) {
						for (int ii = int(temp_min_r); ii <= temp_max_r + 1; ii++) {
							for (int jj = int(temp_min_c); jj < temp_max_c + 1; jj++) {
								if (ii < 0 || ii >= height || jj < 0 || jj >= width) {
									continue;
								}
								p = { double(ii),double(jj),0 };
								//if (PtInRect(p, p1, p2, p3, p4)) {
								p1.z = data(i, j);
								p2.z = data(i, j + 1);
								p3.z = data(i + 1, j + 1);
								p4.z = data(i + 1, j);

								p = invBilinear(p, p1, p2, p3, p4);
								if (isnan(p.z)) {
									continue;
								}
								if (p.x < 0) {
									continue;
								}
								double mean = (p1.z + p2.z + p3.z + p4.z) / 4;
								if (p.z > p1.z && p.z > p2.z && p.z > p3.z && p.z > p4.z) {
									p.z = mean;
								}
								if (p.z < p1.z && p.z < p2.z && p.z < p3.z && p.z < p4.z) {
									p.z = mean;
								}
								grid_data(ii , jj) = p.z;
								//}
							}
						}
					}
				}
			}
			allCount = allCount + line_invert;
			qDebug() << "rows:\t" << allCount << "/" << lon_lat_img.height << "\t  computing.....\t" << getCurrentTimeString() ;
		}
	}
	grid_img.saveImage(grid_data, 0, 0, 1);
	return 0;
}



/*
жϵǷıڣúҲڶΣĳҪı

	pCurǰ
	pLeftTopϽ
	pRightTopϽ
	pRightBelow
	pLeftBelow
ֵıڷ true 򷵻 false
*/

bool PtInRect(Point3 pCur, Point3 pLeftTop, Point3 pRightTop, Point3 pRightBelow, Point3 pLeftBelow)
{
	int nCount = 4;//ı4
	Point3 RectPoints[4] = { pLeftTop, pLeftBelow, pRightBelow, pRightTop };
	int nCross = 0;
	double lastPointX = -999.999;
	for (int i = 0; i < nCount; i++)
	{
		//ȡڵ
		Point3 pBegin = RectPoints[i];
		Point3 pEnd = RectPoints[(i + 1) % nCount];
		//ڵƽx,ǰxƽҪôغ,Ҫôཻ,
		if (pBegin.y == pEnd.y)continue;
		//pBegin,pEndӳ,
		if (pCur.y < min(pBegin.y, pEnd.y) || pCur.y > max(pBegin.y, pEnd.y))continue;
		//ǰxƽpBegin,pEndֱߵĽx
		double x = (double)(pCur.y - pBegin.y) * (double)(pEnd.x - pBegin.x) / (double)(pEnd.y - pBegin.y) + pBegin.x;
		if (x > pCur.x)//ֻpCurұ߽
		{
			if (x != lastPointX)//ֹǵ
			{
				nCross++;
				lastPointX = x;
			}
		}
	}
	// 򽻵Ϊڶ֮
	// 򽻵Ϊżڶ֮
	return (nCross % 2 == 1);
}

int simProcess::ReflectTable_WGS2Range()
{
	gdalImage sim_rc(this->dem_rc_path);
	gdalImage sim_sar_img = CreategdalImage(this->out_ori_sim_tiff, this->pstn.height, this->pstn.width, 2, sim_rc.gt, sim_rc.projection, false);// עﱣ
	gdalImage sim_sar_count_img = CreategdalImage(this->ori_sim_count_tiff, this->pstn.height, this->pstn.width, 1, sim_rc.gt, sim_rc.projection, false);// עﱣ
	gdalImage localIncident_img(this->out_localIncidenct_path);
	for (int max_rows_ids = 0; max_rows_ids < this->pstn.height; max_rows_ids = max_rows_ids + 1000) {
		Eigen::MatrixXd sim_sar = sim_sar_img.getData(max_rows_ids, 0, 1000, this->pstn.width, 1);
		Eigen::MatrixXd sim_sarc = sim_sar_img.getData(max_rows_ids, 0, 1000, this->pstn.width, 2);
		Eigen::MatrixXd sim_sar_count = sim_sar_count_img.getData(max_rows_ids, 0, 1000, this->pstn.width, 1);
		sim_sar = sim_sar.array() * 0 - 9999;
		sim_sarc= sim_sar.array() * 0 - 9999;
		sim_sar_count = sim_sar_count.array() * 0;
		sim_sar_img.saveImage(sim_sar, max_rows_ids, 0, 1);
		sim_sar_img.saveImage(sim_sarc, max_rows_ids, 0, 2);
		sim_sar_count_img.saveImage(sim_sar_count, max_rows_ids, 0, 1);
	}
	sim_sar_img.setNoDataValue(-9999, 1);
	sim_sar_img.setNoDataValue(-9999, 2);
	int conver_lines = 5000;
	int line_invert = 4000;// ص
	int line_offset = 60;
	// 
	omp_lock_t lock;
	omp_init_lock(&lock); // ʼ
	int allCount = 0;

	for (int max_rows_ids = 0; max_rows_ids < sim_rc.height; max_rows_ids = max_rows_ids + line_invert) {
		Eigen::MatrixXd angle = localIncident_img.getData(max_rows_ids, 0, conver_lines, sim_rc.width, 1).cast<double>();
		Eigen::MatrixXd dem_r = sim_rc.getData(max_rows_ids, 0, conver_lines, sim_rc.width, 1);
		Eigen::MatrixXd dem_c = sim_rc.getData(max_rows_ids, 0, conver_lines, sim_rc.width, 2);
		int dem_rows_num = dem_r.rows();
		int dem_cols_num = dem_r.cols();
		// ²ֵγ
		//Eigen::MatrixXd dem_lon = dem_r;
		//Eigen::MatrixXd dem_lat = dem_c;
		//  ¾γȲ

		int temp_r, temp_c;

		int min_row = dem_r.minCoeff() + 1;
		int max_row = dem_r.maxCoeff() + 1;

		if (max_row < 0) {
			continue;
		}

		int len_rows = max_row - min_row;
		min_row = min_row < 0 ? 0 : min_row;
		Eigen::MatrixXd sar_r = sim_sar_img.getData(min_row, 0, len_rows, this->pstn.width, 1);
		Eigen::MatrixXd sar_c = sim_sar_img.getData(min_row, 0, len_rows, this->pstn.width, 2);
		len_rows = sar_r.rows();


		#pragma omp parallel for num_threads(8) // NEW ADD
		for (int i = 0; i < dem_rows_num - 1; i++) {
			for (int j = 0; j < dem_cols_num - 1; j++) {
				Point3 p, p1, p2, p3, p4;
				Landpoint lp1, lp2, lp3, lp4;
				lp1 = sim_rc.getLandPoint(i + max_rows_ids, j, 0);
				lp2 = sim_rc.getLandPoint(i + max_rows_ids, j + 1, 0);
				lp3 = sim_rc.getLandPoint(i + 1 + max_rows_ids, j + 1, 0);
				lp4 = sim_rc.getLandPoint(i + 1 + max_rows_ids, j, 0);

				p1 = { dem_r(i,j),dem_c(i,j) };
				p2 = { dem_r(i,j + 1),dem_c(i,j + 1) };
				p3 = { dem_r(i + 1,j + 1),dem_c(i + 1,j + 1) };
				p4 = { dem_r(i + 1,j),dem_c(i + 1,j) };

				//if (angle(i, j) >= 90 && angle(i, j + 1) >= 90 && angle(i + 1, j) >= 90 && angle(i + 1, j + 1) >= 90) {
				//	continue;
				//}

				double temp_min_r = dem_r.block(i, j, 2, 2).minCoeff();
				double temp_max_r = dem_r.block(i, j, 2, 2).maxCoeff();
				double temp_min_c = dem_c.block(i, j, 2, 2).minCoeff();
				double temp_max_c = dem_c.block(i, j, 2, 2).maxCoeff();
				if ((int(temp_min_r) != int(temp_max_r)) && (int(temp_min_c) != int(temp_max_c))) {
					for (int ii = int(temp_min_r); ii <= temp_max_r + 1; ii++) {
						for (int jj = int(temp_min_c); jj < temp_max_c + 1; jj++) {
							if (ii < min_row || ii - min_row >= len_rows || jj < 0 || jj >= this->pstn.width) {
								continue;
							}
							p = { double(ii),double(jj),-9999 };
							 
							p1.z = lp1.lon;
							p2.z = lp2.lon;
							p3.z = lp3.lon;
							p4.z = lp4.lon;
							
							p = invBilinear(p, p1, p2, p3, p4);
							if (isnan(p.z)) {
								continue;
							}

							if (p.x < 0) {
								continue;
							}
							double mean = (p1.z + p2.z + p3.z + p4.z) / 4;
							if (p.z > p1.z && p.z > p2.z && p.z > p3.z && p.z > p4.z) {
								p.z = mean;
							}
							if (p.z <  p1.z && p.z <  p2.z && p.z < p3.z && p.z < p4.z) {
								p.z = mean;
							}
							sar_r(ii - min_row, jj) = p.z;
							p1.z = lp1.lat;
							p2.z = lp2.lat;
							p3.z = lp3.lat;
							p4.z = lp4.lat;
							p = invBilinear(p, p1, p2, p3, p4);
							if (isnan(p.z)) {
								continue;
							}

							if (p.x < 0) {
								continue;
							}
							mean = (p1.z + p2.z + p3.z + p4.z) / 4;
							if (p.z > p1.z && p.z > p2.z && p.z > p3.z && p.z > p4.z) {
								p.z = mean;
							}
							if (p.z < p1.z && p.z < p2.z && p.z < p3.z && p.z < p4.z) {
								p.z = mean;
							}
							sar_c(ii - min_row, jj) = p.z;
							//}
						}
					}

				}
			}
		}

		omp_set_lock(&lock); //û
		sim_sar_img.saveImage(sar_r, min_row, 0, 1);
		sim_sar_img.saveImage(sar_c, min_row, 0, 2);
		allCount = allCount + conver_lines;
		qDebug() << "rows:\t" << allCount << "/" << sim_rc.height << "\t computing.....\t" << getCurrentTimeString() ;
		omp_unset_lock(&lock); //ͷŻ
	}

	qDebug() << "\t resample computing.....\t" << getCurrentTimeString() ;
	{	int conver = 5000;
	int line_invert = 4000;// ص
	ResampleGDALs(this->out_ori_sim_tiff.toUtf8().constData(), 1, GRIORA_Bilinear);
	ResampleGDALs(this->out_ori_sim_tiff.toUtf8().constData(), 2, GRIORA_Bilinear);
	}

	return 0;
}

int simProcess::InitRPCIncAngle(QString paras_path, QString workspace_path, QString out_dir_path, QString in_dem_path, QString in_rpc_lon_lat_paths, QString out_inc_angle_path, QString out_local_inc_angle_path, QString out_inc_angle_geo_path, QString out_local_inc_angle_geo_path)
{
	this->pstn = PSTNAlgorithm(paras_path); // ʼļ

	this->in_rpc_lon_lat_path = in_rpc_lon_lat_paths;
	this->in_dem_path = in_dem_path;
	this->outSpace_path = out_dir_path;
	this->workSpace_path = workspace_path;

	// ʱļ
	this->dem_path = JoinPath(this->workSpace_path, "SAR_dem.tiff");
	this->dem_rc_path = JoinPath(this->workSpace_path, "dem_rc.tiff");
	this->dem_r_path = JoinPath(this->workSpace_path, "dem_r.tiff");
	this->out_incidence_path = out_inc_angle_geo_path;
	this->out_localIncidenct_path = out_local_inc_angle_geo_path;
	this->rpc_wgs_path = JoinPath(this->workSpace_path, "rcp2dem_wgs.tiff");
	// ļ
	this->out_inc_angle_rpc_path = out_inc_angle_path;
	this->out_local_inc_angle_rpc_path = out_local_inc_angle_path;

	qDebug() << "==========================================================================" ;
	qDebug() << "in_dem_path" << ":\t" << this->in_dem_path ;
	qDebug() << "in_rpc_lon_lat_path" << ":\t" << this->in_rpc_lon_lat_path ;
	qDebug() << "workSpace_path" << ":\t" << this->workSpace_path ;
	qDebug() << "out_dir_path" << ":\t" << this->out_dir_path ;
	qDebug() << "out_inc_angle_path" << ":\t" << this->out_incidence_path ;
	qDebug() << "out_local_inc_angle_path" << ":\t" << this->out_localIncidenct_path ;
	qDebug() << "==========================================================================" ;
	this->createRPCDEM();
	this->dem2SAR_row(); // ȡк
	this->SARIncidentAngle();
	this->SARIncidentAngle_RPC();
	this->in_sar_power();
	return 0;
	return 0;
}

int simProcess::dem2SAR_row()
{

	qDebug() << "the row  of the sar in dem:" << getCurrentTimeString() ;
	{
		gdalImage dem_clip(this->dem_path);
		double dem_mean = dem_clip.mean();
		gdalImage sim_r_reprocess = CreategdalImage(this->dem_r_path, dem_clip.height, dem_clip.width, 1, dem_clip.gt, dem_clip.projection);
		gdalImage sim_rc_reprocess = CreategdalImage(this->dem_rc_path, dem_clip.height, dem_clip.width, 2, dem_clip.gt, dem_clip.projection);
		int line_invert = int(15000000 / dem_clip.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int count_lines = 0;
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
#pragma omp parallel for num_threads(8) // NEW ADD
		for (int max_rows_ids = 0; max_rows_ids < dem_clip.height; max_rows_ids = max_rows_ids + line_invert) {
			//line_invert = dem_clip.height - max_rows_ids > line_invert ? line_invert : dem_clip.height - max_rows_ids;

			Eigen::MatrixXd demdata = dem_clip.getData(max_rows_ids, 0, line_invert, dem_clip.width, 1);

			Eigen::MatrixXd sim_r = demdata.array() * 0;
			Eigen::MatrixXd sim_c = demdata.array() * 0;

			int datarows = demdata.rows();
			int datacols = demdata.cols();
			Eigen::MatrixX<double> landpoint(datarows * datacols, 3);
			for (int i = 0; i < datarows; i++) {
				for (int j = 0; j < datacols; j++) {
					landpoint(i * datacols + j, 0) = i + max_rows_ids;
					landpoint(i * datacols + j, 1) = j;
					landpoint(i * datacols + j, 2) = demdata(i, j); // Ϊ0 Ϊʼ0ֵ
				}
			}
			landpoint = dem_clip.getLandPoint(landpoint);
			//landpoint.col(2) = landpoint.col(2).array() * 0;
			landpoint = LLA2XYZ(landpoint);
			landpoint = this->pstn.PSTN(landpoint, dem_mean); // time,r,c
			//qDebug() << "for time " << getCurrentTimeString() ;
			for (int i = 0; i < datarows; i++) {
				for (int j = 0; j < datacols; j++) {
					sim_r(i, j) = landpoint(i * datacols + j, 1);
					sim_c(i, j) = landpoint(i * datacols + j, 2);
				}
			}
			//qDebug() << "for time " << getCurrentTimeString() ;
			// д뵽ļ
			omp_set_lock(&lock); //û
			sim_r_reprocess.saveImage(sim_r, max_rows_ids, 0, 1);
			sim_rc_reprocess.saveImage(sim_r, max_rows_ids, 0, 1);
			sim_rc_reprocess.saveImage(sim_c, max_rows_ids, 0, 2);
			count_lines = count_lines + line_invert;
			qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << dem_clip.height << "\t computing.....\t" << getCurrentTimeString() ;
			omp_unset_lock(&lock); //ͷŻ
		}
		omp_destroy_lock(&lock); //ٻ
		qDebug() << "dem2SAR_Row_col  dem_2_sarRC  over " << getCurrentTimeString() ;

		qDebug() << "=========================================\n";
		qDebug() << "the row and col of the sar in dem:\n";
		qDebug() << this->dem_r_path << "\n";
		qDebug() << "band 1 : the row of the  sar  \n";
		qDebug() << "=========================================\n";
	}
	return 0;
}

/// <summary>
/// RPC
/// </summary>
/// <returns></returns>
int simProcess::SARIncidentAngle_RPC() {
	this->calGEC_Incident_localIncident_angle(this->dem_path, this->in_rpc_lon_lat_path, this->out_inc_angle_rpc_path, this->out_local_inc_angle_rpc_path, this->pstn);
	return 0;
}

int simProcess::createRPCDEM()
{
	qDebug() << "dem2SAR_Row_col begin time:" << getCurrentTimeString() ;
	{
		gdalImage dem(this->in_dem_path);
		gdalImage lonlat(this->in_rpc_lon_lat_path);
		DemBox box{ 9999,9999,-9999,-9999 };
		{
			int start_ids = 0;
			int line_invert = int(4000000 / dem.width);
			line_invert = line_invert > 10 ? line_invert : 10;
			for (start_ids = 0; start_ids < this->pstn.height; start_ids = start_ids + line_invert) {
				qDebug() << "rows:\t" << start_ids << "/" << this->pstn.height << "\t computing.....\t" << getCurrentTimeString() ;
				Eigen::MatrixXd	lon = lonlat.getData(start_ids, 0, line_invert, this->pstn.width, 1);
				Eigen::MatrixXd	lat = lonlat.getData(start_ids, 0, line_invert, this->pstn.width, 2);
				double min_lat = lat.array().minCoeff();
				double max_lat = lat.array().maxCoeff();
				double min_lon = lon.array().minCoeff();
				double max_lon = lon.array().maxCoeff();
				box.min_lat = min_lat < box.min_lat ? min_lat : box.min_lat;
				box.max_lat = max_lat > box.max_lat ? max_lat : box.max_lat;;
				box.min_lon = min_lon < box.min_lon ? min_lon : box.min_lon;;
				box.max_lon = max_lon > box.max_lon ? max_lon : box.max_lon;;

			}
		}
		qDebug() << "prepare over" << getCurrentTimeString() ;
		double dist_lat = box.max_lat - box.min_lat;
		double dist_lon = box.max_lon - box.min_lon;
		dist_lat = 0.1 * dist_lat;
		dist_lon = 0.1 * dist_lon;
		box.min_lat = box.min_lat - dist_lat;
		box.max_lat = box.max_lat + dist_lat;
		box.min_lon = box.min_lon - dist_lon;
		box.max_lon = box.max_lon + dist_lon;

		qDebug() << "box:" ;
		qDebug() << "min_lat-max_lat:\t" << box.min_lat << "\t" << box.max_lat ;
		qDebug() << "min_lon-max_lon:\t" << box.min_lon << "\t" << box.max_lon ;
		qDebug() << "cal box of sar over" ;

		// ֮ӰС
		int width = 1.5 * this->pstn.width;
		int height = 1.5 * this->pstn.height;

		double heightspace = (box.max_lat - box.min_lat) / height;
		double widthspace = (box.max_lon - box.min_lon) / width;
		qDebug() << "resample dem:\n" << getCurrentTimeString() ;
		qDebug() << "in_dem:\t" << this->in_dem_path ;
		qDebug() << "out_dem:\t" << this->dem_path ;
		qDebug() << "width-height:\t" << width << "-" << height ;
		qDebug() << "widthspace\t-\theight\tspace:\t" << widthspace << "\t-\t" << heightspace ;

		int pBandIndex[1] = { 1 };
		int pBandCount[1] = { 1 };

		double gt[6] = {
			box.min_lon,widthspace,0,	 //x
			box.max_lat,0,-heightspace//y
		};

		//boost::filesystem::copy(dem_path, this->dem_path);
		ResampleGDAL(this->in_dem_path.toUtf8().constData(), this->dem_path.toUtf8().constData(), gt, width, height, GRA_Bilinear);

		qDebug() << "resample dem over:\n" << getCurrentTimeString() ;
		qDebug() << "remove sim_rc_path:\t" << this->dem_rc_path ;
	}

	return 0;
}


/// <summary>
/// ģSARӰ
/// </summary>
/// <param name="dem_path">demӰ</param>
/// <param name="sim_rc_path">rc Ӱ</param>
/// <param name="sim_sar_path">ģsarӰ</param>
/// <param name="PSTN"></param>
/// <returns>ִ״̬</returns>
int simProcess::sim_SAR(QString dem_path, QString sim_rc_path, QString sim_sar_path, PSTNAlgorithm PSTN)
{
	qDebug() << "computer the simulation value of evering dem meta,      begining:\t" << getCurrentTimeString() ;
	gdalImage dem_img(dem_path);
	gdalImage sim_rc(sim_rc_path);
	gdalImage sim_sar = CreategdalImage(sim_sar_path, dem_img.height, dem_img.width, 2, dem_img.gt, dem_img.projection);// עﱣ
	sim_sar.setNoDataValue(-9999, 1);
	double PRF = this->pstn.PRF;
	double imgstarttime = this->pstn.imgStartTime;
	int line_invert = int(50000000 / dem_img.width);// С
	line_invert = line_invert > 100 ? line_invert : 100;
	int start_ids = 0; // ʾ1
	int line_width = dem_img.width;
	Eigen::MatrixX<double> sim_r(line_invert, line_width);
	Eigen::MatrixXd sim_c(line_invert, line_width);
	Eigen::MatrixXd dem(line_invert, line_width);
	Eigen::MatrixXd sim_rsc(line_invert, line_width);
	Eigen::MatrixXd sim_inclocal(line_invert, line_width);

	int rowcount = 0, colcount = 0;
	//omp_lock_t lock;
	//omp_init_lock(&lock); // ʼ
	do {
		qDebug() << "rows:\t" << start_ids << "-" << start_ids + line_invert + 2 << "/" << dem_img.height << "\t computing.....\t" << getCurrentTimeString() ;
		dem = dem_img.getData(start_ids, 0, line_invert + 2, line_width, 1);
		sim_r = sim_rc.getData(start_ids, 0, line_invert + 2, line_width, 1).cast<double>();
		sim_r = sim_r.array() * (1 / PRF) + imgstarttime;
		//sim_c = sim_rc.getData(start_ids, 0, line_invert + 1, line_width, 2);
		sim_rsc = dem.array() * 0;
		sim_inclocal = dem.array() * 0 - 9999;
		rowcount = dem.rows();
		colcount = dem.cols();


#pragma omp parallel for num_threads(4) // NEW ADD
		for (int i = 1; i < rowcount - 1; i++) {
			Eigen::MatrixX<double> sataState = sim_r.row(i).reshaped(line_width, 1);
			sataState = this->pstn.orbit.SatelliteSpacePoint(sataState);
			Landpoint p0, p1, p2, p3, p4, slopeVector, landpoint, satepoint;
			double localincangle;
			for (int j = 1; j < colcount - 1; j++) {
				p0 = dem_img.getLandPoint(i + start_ids, j, dem(i, j)); // 
				p1 = dem_img.getLandPoint(i + start_ids - 1, j, dem(i - 1, j)); // 1 
				p2 = dem_img.getLandPoint(i + start_ids, j + 1, dem(i, j + 1)); // 2
				p3 = dem_img.getLandPoint(i + start_ids + 1, j, dem(i + 1, j)); // 3
				p4 = dem_img.getLandPoint(i + start_ids, j - 1, dem(i, j - 1)); // 4
				slopeVector = getSlopeVector(p0, p1, p2, p3, p4);
				landpoint = LLA2XYZ(p0);
				satepoint = Landpoint{ sataState(j,0),sataState(j,1) ,sataState(j,2) };
				localincangle = getlocalIncAngle(satepoint, landpoint, slopeVector);
				sim_inclocal(i, j) = localincangle;
				if (localincangle < 90)
				{
					localincangle = localincangle * d2r;
					sim_rsc(i, j) = 100 * double((0.0133 * cos(localincangle) / pow(sin(localincangle + 0.1 * localincangle), 3)));
					//sim_rsc(i, j) = sim_rsc(i, j) > 100 ? -9999 : sim_rsc(i, j);
				}
			}
		}
		//omp_set_lock(&lock); //û
		//qDebug() << sim_rsc(1, 1961) ;

		Eigen::MatrixXd sim_rscblock = sim_rsc.block(1, 0, rowcount - 2, colcount);
		Eigen::MatrixXd sim_inclocalblock = sim_rsc.block(1, 0, rowcount - 2, colcount);
		sim_sar.saveImage(sim_rscblock, start_ids + 1, 0, 1);
		sim_sar.saveImage(sim_inclocalblock, start_ids + 1, 0, 2);
		//omp_unset_lock(&lock); //ͷŻ
		start_ids = start_ids + line_invert - 4;
	} while (start_ids < dem_img.height);
	//omp_destroy_lock(&lock); //ٻ
	qDebug() << "computer the simulation value of evering dem meta,      over:\t" << getCurrentTimeString() ;
	qDebug() << "==========================================================" ;
	qDebug() << "the simulation sar value Raster has the projection that is same of dem" ;
	qDebug() << sim_sar_path ;
	qDebug() << "band 1: the simulation sar value" ;
	qDebug() << "band 2: the local incident angle " ;
	qDebug() << "==========================================================" ;
	return 0;
}


int simProcess::dem2aspect_slope(QString dem_path, QString aspect_path, QString slope_path)
{
	qDebug() << "computer aspect and slop begining:\t" << getCurrentTimeString() ;

	GDALAllRegister();// עʽ
	GDALDriver* poDriver = GetGDALDriverManager()->GetDriverByName("GTiff");
	GDALDataset* dem = (GDALDataset*)(GDALOpen(dem_path.toUtf8().constData(), GA_ReadOnly));
	GDALDEMProcessing(aspect_path.toUtf8().constData(), dem, "aspect", NULL, NULL, NULL);
	GDALDEMProcessing(slope_path.toUtf8().constData(), dem, "slope", NULL, NULL, NULL);
	GDALClose(dem);
	qDebug() << "computer aspect and slop overing:\t" << getCurrentTimeString() ;
	return 0;
}

/// <summary>
/// ǰģкţģͼɲĿ
/// </summary>
/// <param name="sim_rc_path">к</param>
/// <param name="sim_orth_path">䵥Ԫ</param>
/// <param name="sim_sum_path">ģӰ·</param>
/// <returns></returns>
int simProcess::sim_sum_SAR(QString sim_dem_path, QString sim_rc_path, QString sim_orth_path, QString sim_sum_path, PSTNAlgorithm PSTN)
{
	qDebug() << "computer the simulation value of sim_sar,      begining:\t" << getCurrentTimeString() ;
	//gdalImage dem_img(dem_path);
	gdalImage sim_rc(sim_rc_path);
	gdalImage sim_rsc(sim_orth_path);
	gdalImage dem(sim_dem_path);
	gdalImage sim_sar = CreategdalImage(sim_sum_path, this->pstn.height, this->pstn.width, 1, sim_rc.gt, sim_rc.projection, false);// עﱣ
	{
		sim_sar.setNoDataValue(-9999, 1);
		//double PRF = this->pstn.PRF;
		//double imgstarttime = this->pstn.imgStartTime;
		int line_invert = int(16000000 / sim_rc.width);// С
		line_invert = line_invert > 100 ? line_invert : 100;
		int start_ids = 0; // ʾ1
		int line_width = sim_rc.width;
		Eigen::MatrixX<double> sim_r(line_invert, line_width);
		Eigen::MatrixXd sim_c(line_invert, line_width);
		Eigen::MatrixXd sim_sum_h(line_invert, line_width);
		Eigen::MatrixXd sim_rsc_orth(line_invert, line_width);
		Eigen::MatrixXd sim_sum_sar(line_invert, line_width);
		Eigen::MatrixXd sim_sum_count(line_invert, line_width);
		Eigen::MatrixXd demdata(line_invert, line_width);

		// ʼ
		do {
			sim_sum_sar = sim_sar.getData(start_ids, 0, line_invert, this->pstn.width, 1).cast<double>();
			sim_sum_sar = sim_sum_sar.array() * 0;
			sim_sar.saveImage(sim_sum_sar, start_ids, 0, 1);
			sim_sar.saveImage(sim_sum_sar, start_ids, 0, 2);
			sim_sar.saveImage(sim_sum_sar, start_ids, 0, 3);
			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);
		{
			// ۼӼģֵ
			int rowcount = 0, colcount = 0;
			int row_min = 0, row_max = 0;
			start_ids = 0;
			qDebug() << "time:\tsim_arr_row_min\tsim_arr_row_max\tsim_arr_all_lines\tsim_row_min\tsim_row_max\tsim_row_min0\tsim_row_max0" ;;


			do {
				qDebug() << "\n" << getCurrentTimeString() << "\t" << start_ids << "\t" << start_ids + line_invert << "\t" << sim_rc.height << "\t";
				sim_r = sim_rc.getData(start_ids, 0, line_invert, line_width, 1).cast<double>(); // 
				sim_c = sim_rc.getData(start_ids, 0, line_invert, line_width, 2).cast<double>(); // 

				sim_rsc_orth = sim_rsc.getData(start_ids, 0, line_invert, line_width, 1).cast<double>(); // ֵ
				demdata = dem.getData(start_ids, 0, line_invert, line_width, 1).cast<double>(); // ֵ
				// Χ
				row_min = (floor(sim_r.minCoeff()));
				row_max = (ceil(sim_r.maxCoeff()));
				qDebug() << row_min << "\t" << row_max << "\t";

				//qDebug() << "line range:\t" << row_min << " - " << row_max  << "\t computing.....\t" << getCurrentTimeString() ;

				if (row_max < 0 || row_min>this->pstn.height) {
					start_ids = start_ids + line_invert;
					continue;
				}
				row_min = row_min <= 0 ? 0 : row_min;
				row_max = row_max >= this->pstn.height ? this->pstn.height : row_max;
				qDebug() << row_min << "\t" << row_max ;
				//sim_sum_sar =sim_sar.getData(row_min, 0, row_max-row_min+1, this->pstn.width, 1).cast<double>();
				//sim_sum_count = sim_sar.getData(row_min, 0, row_max - row_min + 1, this->pstn.width, 2).cast<double>();
				if (row_min >= row_max) {
					break;
				}
				sim_sum_sar = sim_sar.getData(row_min, 0, row_max - row_min + 1, this->pstn.width, 1).cast<double>();
				sim_sum_count = sim_sar.getData(row_min, 0, row_max - row_min + 1, this->pstn.width, 2).cast<double>();
				sim_sum_h = sim_sar.getData(row_min, 0, row_max - row_min + 1, this->pstn.width, 3).cast<double>(); // 
				rowcount = sim_r.rows();
				colcount = sim_r.cols();

#pragma omp parallel for num_threads(4) // NEW ADD
				for (int i = 0; i < rowcount; i++) {
					int row_ids = 0, col_ids = 0;
					for (int j = 0; j < colcount; j++) {
						row_ids = int(round(sim_r(i, j)));
						col_ids = int(round(sim_c(i, j)));
						if (row_ids >= 0 && row_ids < this->pstn.height && col_ids >= 0 && col_ids < this->pstn.width) {
							sim_sum_sar(row_ids - row_min, col_ids) += sim_rsc_orth(i, j);
							sim_sum_count(row_ids - row_min, col_ids) += 1;
							sim_sum_h(row_ids - row_min, col_ids) += demdata(i, j);
						}
					}
				}
				sim_sar.saveImage(sim_sum_sar, row_min, 0, 1);
				sim_sar.saveImage(sim_sum_count, row_min, 0, 2);
				sim_sar.saveImage(sim_sum_h, row_min, 0, 3);

				start_ids = start_ids + line_invert;
			} while (start_ids < sim_rc.height);
			qDebug() << "\ncomputer the simulation value of sim_sar,    overing  :\t" << getCurrentTimeString() ;
		}
	}
	{
		qDebug() << "computer the height of sim_sar,    begining  :\t" << getCurrentTimeString() ;
		Eigen::MatrixXd sim_sum_h(1, 1);
		Eigen::MatrixXd sim_sum_count(1, 1);

		int start_ids = 0;
		int line_invert = int(8000000 / this->pstn.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int row_count = 0, col_count = 0;
		do {
			sim_sum_count = sim_sar.getData(start_ids, 0, line_invert, this->pstn.width, 2).cast<double>(); // 
			sim_sum_h = sim_sar.getData(start_ids, 0, line_invert, this->pstn.width, 3).cast<double>(); // 
			row_count = sim_sum_h.rows();
			col_count = sim_sum_h.cols();
			qDebug() << "min~max:" ;
			qDebug() << sim_sum_count.minCoeff() << "\t" << sim_sum_count.maxCoeff() ;
			qDebug() << sim_sum_h.minCoeff() << "\t" << sim_sum_h.maxCoeff() ;
			for (int i = 0; i < row_count; i++) {
				for (int j = 0; j < col_count; j++) {
					if (sim_sum_count(i, j) == 0) {
						sim_sum_h(i, j) = 0;
					}
					else {
						sim_sum_h(i, j) = sim_sum_h(i, j) / sim_sum_count(i, j);
					}
				}
			}
			sim_sar.saveImage(sim_sum_h, start_ids, 0, 3);
			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);

		qDebug() << "computer the height of sim_sar,    overing  :\t" << getCurrentTimeString() ;
	}

	{
		qDebug() << "compute the average value of sim_sar, beiging:\t" << getCurrentTimeString() ;

		//ResampleGDALs(sim_sum_path.toUtf8().constData(), 1, GRIORA_Bilinear);
		//ResampleGDALs(sim_sum_path.toUtf8().constData(), 3, GRIORA_Bilinear);
		qDebug() << "compute the average value of sim_sar,  over :\t" << getCurrentTimeString() ;
	}
	{
		qDebug() << "=========================================\n";
		qDebug() << "sim_sar_tif infomation  :\n";
		qDebug() << sim_sum_path << "\n";
		qDebug() << "band 1 : simulation sar value  \n";
		qDebug() << "band 2 : the sum of the  effective value from the dem \n";
		qDebug() << "band 3 : the dem altitude of the effective value from the dem  \n";
		qDebug() << "=========================================\n";

	}
	return 0;
}


/// <summary>
/// 
/// </summary>
/// <param name="ori_sar_path"></param>
/// <param name="out_sar_power_path"></param>
/// <returns></returns>
int simProcess::ori_sar_power(QString ori_sar_path, QString out_sar_power_path)
{
	qDebug() << "compute the power value of ori sar, beiging:\t" << getCurrentTimeString() ;
	gdalImage ori_sar(ori_sar_path);
	gdalImage sim_power = CreategdalImage(out_sar_power_path, ori_sar.height, ori_sar.width, 1, ori_sar.gt, ori_sar.projection);
	sim_power.setNoDataValue(-9999, 1);
	{
		Eigen::MatrixXd band1(1, 1);
		Eigen::MatrixXd band2(1, 1);
		Eigen::MatrixXd power_value(1, 1);
		int start_ids = 0;
		int line_invert = int(8000000 / ori_sar.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int row_count = 0, col_count = 0;
		do {
			qDebug() << "rows:\t" << start_ids << "/" << ori_sar.height << "\t computing.....\t" << getCurrentTimeString() ;
			band1 = ori_sar.getData(start_ids, 0, line_invert, ori_sar.width, 1).cast<double>(); // a
			band2 = ori_sar.getData(start_ids, 0, line_invert, ori_sar.width, 2).cast<double>(); // b
			//power_value = band2.array() * 0-9999;
			power_value = (band1.array().pow(2) + band2.array().pow(2) + 1).log10() * 10;// 10 * Eigen::log10(Eigen::pow(0.5, Eigen::pow(2, band1.array()) + Eigen::pow(2, band2.array()))).array();
			//if () {
			//
			//}//			power_value.isNaN())
																								 //qDebug() << power_value.minCoeff() << "\t" << power_value.maxCoeff() << "\t" ;
			//qDebug() << "band 1\t" << band1.minCoeff() << "\t" << band1.maxCoeff() << "\t" ;
			//qDebug() << "band 2\t" << band2.minCoeff() << "\t" << band2.maxCoeff() << "\t" ;
			sim_power.saveImage(power_value, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < ori_sar.height);
	}
	{
		qDebug() << "Resample the power value of ori sar :\t" << getCurrentTimeString() ;
		ResampleGDALs(out_sar_power_path.toUtf8().constData(), 1, GRIORA_Cubic);
	}
	qDebug() << "compute the power value of ori sar, ending:\t" << getCurrentTimeString() ;
	{
		qDebug() << "=========================================\n";
		qDebug() << " the power image of  sar  :\n";
		qDebug() << out_sar_power_path << "\n";
		qDebug() << "band 1 : power value   \t  10*log10(b1^2+b2^2)   \n";
		qDebug() << "=========================================\n";

	}
	return 0;
}

 

 
/// <summary>
/// 
/// </summary>
/// <param name="orth_rc_path"></param>
/// <param name="dem_path"></param>
/// <param name="out_inclocal_path"></param>
/// <param name="out_dem_path">dem</param>
/// <param name="out_count_path">counttif</param>
/// <returns></returns>
int simProcess::correct_ati(QString orth_rc_path, QString dem_path, QString out_inclocal_path, QString out_dem_path, QString out_count_path, PSTNAlgorithm PSTN)
{
	qDebug() << "computer the simulation value of evering dem meta,      begining:\t" << getCurrentTimeString() ;
	gdalImage dem_img(dem_path);
	gdalImage orth_rc(orth_rc_path);

	gdalImage ori_inclocal = CreategdalImage(out_inclocal_path, this->pstn.height, this->pstn.width, 1, orth_rc.gt, orth_rc.projection, false);// עﱣ
	gdalImage ori_dem = CreategdalImage(out_dem_path, this->pstn.height, this->pstn.width, 1, orth_rc.gt, orth_rc.projection, false);// עﱣ
	gdalImage ori_count = CreategdalImage(out_count_path, this->pstn.height, this->pstn.width, 1, orth_rc.gt, orth_rc.projection, false);// עﱣ


	// ʼ
	{
		int line_invert = int(500000 / this->pstn.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		do {
			Eigen::MatrixXd	sar_dem = ori_dem.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_inclocal = ori_inclocal.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_count = ori_count.getData(start_ids, 0, line_invert, this->pstn.width, 1);

			sar_dem = sar_dem.array() * 0;
			sar_inclocal = sar_inclocal.array() * 0;
			sar_count = sar_count.array() * 0;

			ori_dem.saveImage(sar_dem, start_ids, 0, 1);
			//ori_inclocal.saveImage(sar_inclocal, start_ids, 0, 1);
			ori_count.saveImage(sar_count, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);
	}

	{
		double PRF = this->pstn.PRF;
		double imgstarttime = this->pstn.imgStartTime;
		int line_invert = int(50000000 / dem_img.width);// С
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0; // ʾ1
		int line_width = dem_img.width;
		Eigen::MatrixX<double> sar_r(line_invert, line_width);
		Eigen::MatrixXd sar_c(line_invert, line_width);
		Eigen::MatrixXd dem(line_invert, line_width);
		Eigen::MatrixXd sar_dem;
		Eigen::MatrixXd sar_inclocal;
		Eigen::MatrixXd sar_count;

		int rowcount = 0, colcount = 0;
		int r_min, r_max, c_min, c_max;
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
		do {
			qDebug() << "rows:\t" << start_ids << "-" << start_ids + line_invert + 2 << "/" << dem_img.height << "\t computing.....\t" << getCurrentTimeString() ;
			dem = dem_img.getData(start_ids, 0, line_invert + 2, line_width, 1);
			sar_r = orth_rc.getData(start_ids, 0, line_invert + 2, line_width, 1).cast<double>();
			sar_c = orth_rc.getData(start_ids, 0, line_invert + 2, line_width, 2).cast<double>();

			r_min = int(floor(sar_r.minCoeff()));
			r_max = int(ceil(sar_r.maxCoeff()));

			c_min = int(floor(sar_c.minCoeff()));
			c_max = int(ceil(sar_c.maxCoeff()));


			// ݽ
			rowcount = r_max - r_min + 1;
			colcount = c_max - c_min + 1;

			if (r_max < 0 || r_min>this->pstn.height) {
				start_ids = start_ids + line_invert;
				continue;
			}
			r_min = r_min <= 0 ? 0 : r_min;
			r_max = r_max >= this->pstn.height ? this->pstn.height : r_max;

			sar_dem = ori_dem.getData(r_min, 0, r_max - r_min + 1, this->pstn.width, 1).cast<double>();
			sar_count = ori_count.getData(r_min, 0, r_max - r_min + 1, this->pstn.width, 1).cast<double>();
			sar_inclocal = ori_inclocal.getData(r_min, 0, r_max - r_min + 1, this->pstn.width, 1).cast<double>(); // 

			rowcount = dem.rows();
			colcount = dem.cols();
#pragma omp parallel for num_threads(8) // NEW ADD
			for (int i = 1; i < rowcount - 1; i++) {
				Eigen::MatrixX<double> sataState = sar_r.row(i).reshaped(line_width, 1).array() * (1 / PRF) + imgstarttime;
				sataState = this->pstn.orbit.SatelliteSpacePoint(sataState);
				Landpoint p0, p1, p2, p3, p4, slopeVector, landpoint, satepoint;
				double localincangle;
				int r, c;
				for (int j = 1; j < colcount - 1; j++) {
					p0 = dem_img.getLandPoint(i + start_ids, j, dem(i, j)); // 
					p1 = dem_img.getLandPoint(i + start_ids - 1, j, dem(i - 1, j)); // 1 
					p2 = dem_img.getLandPoint(i + start_ids, j + 1, dem(i, j + 1)); // 2
					p3 = dem_img.getLandPoint(i + start_ids + 1, j, dem(i + 1, j)); // 3
					p4 = dem_img.getLandPoint(i + start_ids, j - 1, dem(i, j - 1)); // 4
					slopeVector = getSlopeVector(p0, p1, p2, p3, p4);
					landpoint = LLA2XYZ(p0);
					satepoint = Landpoint{ sataState(j,0),sataState(j,1) ,sataState(j,2) };
					localincangle = getlocalIncAngle(satepoint, landpoint, slopeVector);

					if (localincangle < 90)
					{
						r = sar_r(i, j);
						c = sar_c(i, j);
						if (r >= 0 && r < this->pstn.height && c >= 0 && c < this->pstn.width) {
							sar_inclocal(r - r_min, c) += localincangle;
							sar_count(r - r_min, c) += 1;
							sar_dem(r - r_min, c) += dem(i, j);
						}
					}
				}
			}
			//qDebug() << sim_rsc(1, 1961) ;
			ori_dem.saveImage(sar_dem, r_min, 0, 1);
			//ori_inclocal.saveImage(sar_inclocal, r_min, 0, 1);
			ori_count.saveImage(sar_count, r_min, 0, 1);
			start_ids = start_ids + line_invert - 4;
		} while (start_ids < dem_img.height);
		omp_destroy_lock(&lock); //ٻ
	}

	// ƽ
	{
		int line_invert = int(500000 / this->pstn.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		do {
			Eigen::MatrixXd	sar_dem = ori_dem.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_inclocal = ori_inclocal.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_count = ori_count.getData(start_ids, 0, line_invert, this->pstn.width, 1);

			sar_dem = sar_dem.array() / sar_count.array();
			sar_inclocal = sar_inclocal.array() / sar_count.array();

			ori_dem.saveImage(sar_dem, start_ids, 0, 1);
			//ori_inclocal.saveImage(sar_inclocal, start_ids, 0, 1);

			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);
	}

	qDebug() << "repair dem by resample,     begining:\t" << getCurrentTimeString() ;
	{


	}
	qDebug() << "repair dem by resample,     overing:\t" << getCurrentTimeString() ;

	qDebug() << "correct the evering dem meta,      over:\t" << getCurrentTimeString() ;
	qDebug() << "==========================================================" ;
	qDebug() << "the dem of sar:\t" << out_dem_path ;
	qDebug() << "the local incident angle of sar:\t " << out_inclocal_path ;
	qDebug() << "==========================================================" ;
	return 0;
}

int simProcess::ASF(QString in_dem_path, QString out_latlon_path, ASFOrthClass asfclass, PSTNAlgorithm PSTN)
{
	qDebug() << "computer ASF,      begining:\t" << getCurrentTimeString() ;
	qDebug() << "==========================================================" ;
	qDebug() << "in parameters" ;
	qDebug() << "the dem of sar:\t" << in_dem_path ;
	qDebug() << "in sar rc path:\t" << in_dem_path ;
	qDebug() << "out parameters" ;
	qDebug() << "out latlon of sar:\t" << out_latlon_path ;
	qDebug() << "==========================================================" ;


	gdalImage dem(in_dem_path);
	gdalImage latlon = CreategdalImage(out_latlon_path, this->pstn.height, this->pstn.width, 2, dem.gt, dem.projection, false);
	//gdalImage sar_rc(in_sar_rc_path);
	// ʼ
	double aveageAti = 0;
	{
		int line_invert = int(500000 / dem.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		int count = 0;
		do {
			Eigen::MatrixXd	sar_dem = dem.getData(start_ids, 0, line_invert, dem.width, 1);
			int row_count = sar_dem.rows();
			int col_count = sar_dem.cols();
			for (int i = 0; i < row_count; i++) {
				for (int j = 0; j < col_count; j++) {
					if (!isnan(sar_dem(i, j)) && !isinf(sar_dem(i, j))) {
						aveageAti += sar_dem(i, j);
						count = count + 1;
					}
				}
			}
			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);
		aveageAti = aveageAti / count;
	}
	cout << "the aveage ati of dem:\t" << aveageAti ;
	// ʼ
	Landpoint initp = dem.getLandPoint(int(dem.height / 2), int(dem.width / 2), aveageAti);

	cout << "initlandpoint lon lat ati\t" << initp.lon << "\t" << initp.lat << "\t" << initp.ati << "\t" ;
	initp = LLA2XYZ(initp);
	cout << "initlandpoint lon lat ati\t" << initp.lon << "\t" << initp.lat << "\t" << initp.ati << "\t" ;

	double PRF = this->pstn.PRF;
	double imgstarttime = this->pstn.imgStartTime;
	double alpha0 = 0;
	// 
	{
		int line_invert = int(1000000 / dem.width) > 10 ? int(1000000 / dem.width) : 10;
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ
#pragma omp parallel for num_threads(8) // NEW ADD
		for (int start_ids = 0; start_ids < this->pstn.height; start_ids = start_ids + line_invert)
		{
			Eigen::MatrixXd	sar_dem = dem.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_lon = latlon.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_lat = latlon.getData(start_ids, 0, line_invert, this->pstn.width, 2);
			Eigen::Vector3d initTagetPoint(initp.lon, initp.lat, initp.ati);
			int row_min = start_ids;
			int row_max = sar_lon.rows() + row_min;
			qDebug() << "rows:\t" << row_min << "-" << row_max << "/" << this->pstn.height << "\t computing.....\t" << getCurrentTimeString() ;

			for (int i = row_min; i < row_max; i++) {
				long double satetime = i * (1 / PRF) + imgstarttime;
				Eigen::MatrixXd sataspace = this->pstn.orbit.SatelliteSpacePoint(satetime); // ռ
				Eigen::Vector3d SatellitePosition(sataspace(0, 0), sataspace(0, 1), sataspace(0, 2));
				Eigen::Vector3d SatelliteVelocity(sataspace(0, 3), sataspace(0, 4), sataspace(0, 5));
				Landpoint sata{ sataspace(0,0), sataspace(0, 1), sataspace(0, 2) };

				double beta0 = 50 * d2r;// (180-getAngle(sata, sata-initp))* d2r;

				for (int j = 0; j < this->pstn.width; j++) {
					double R = getRangebyColumn(j, this->pstn.R0, this->pstn.fs, this->pstn.lamda);
					double ati_H = sar_dem(i - row_min, j);
					if (!isnan(ati_H) && !isinf(ati_H)) {
						ati_H = aveageAti;
					}
					Eigen::Vector3d landp = asfclass.ASF(R, SatellitePosition, SatelliteVelocity, initTagetPoint, PSTN, this->pstn.R0, ati_H, alpha0, beta0);
					Landpoint landpoint{ landp(0),landp(1) ,landp(2) };
					landpoint = XYZ2LLA(landpoint);
					sar_lon(i - row_min, j) = landpoint.lon;
					sar_lat(i - row_min, j) = landpoint.lat;
				}
			}
			omp_set_lock(&lock);
			latlon.saveImage(sar_lon, row_min, 0, 1);
			latlon.saveImage(sar_lat, row_min, 0, 2);
			omp_unset_lock(&lock);
		}
		omp_destroy_lock(&lock); //ٻ
	}
	qDebug() << "out lon and lat of sar,   over:\t" << getCurrentTimeString() ;
	qDebug() << "==========================================================" ;
	qDebug() << "the lon lat of sar:\t" << out_latlon_path ;
	qDebug() << "band 1: lon" ;
	qDebug() << "band 2: lat " ;
	qDebug() << "==========================================================" ;

	return 0;
}
/// <summary>
/// Ǻ;
/// </summary>
/// <param name="in_dem_path"></param>
/// <param name="in_rc_wgs84_path"></param>
/// <param name="out_incident_angle_path"></param>
/// <param name="out_local_incident_angle_path"></param>
/// <param name="PSTN"></param>
void simProcess::calcalIncident_localIncident_angle(QString in_dem_path, QString in_rc_wgs84_path, QString out_incident_angle_path, QString out_local_incident_angle_path, PSTNAlgorithm PSTN)
{
	this->calGEC_Incident_localIncident_angle(in_dem_path, in_rc_wgs84_path, out_incident_angle_path, out_local_incident_angle_path, PSTN);
}

/// <summary>
/// ȡGECϵµ
/// </summary>
/// <param name="in_dem_path"></param>
/// <param name="in_gec_lon_lat_path"></param>
/// <param name="out_incident_angle_path"></param>
/// <param name="out_local_incident_angle_path"></param>
/// <param name="PSTN"></param>
void simProcess::calGEC_Incident_localIncident_angle(QString in_dem_path, QString in_gec_lon_lat_path, QString  out_incident_angle_path, QString out_local_incident_angle_path, PSTNAlgorithm PSTN)
{
	qDebug() << "computer Incident_localIncident_angle in sar,      begining:\t" << getCurrentTimeString() ;
	qDebug() << "==========================================================" ;
	qDebug() << "in parameters" ;
	qDebug() << "the dem in wgs84 of sar:\t" << in_dem_path ;
	qDebug() << "in gec lon lat path:\t" << in_gec_lon_lat_path ;
	qDebug() << "out parameters" ;
	qDebug() << "out incident_angle of sar:\t" << out_incident_angle_path ;
	qDebug() << "out local incident_angle of sar:\t" << out_local_incident_angle_path ;
	qDebug() << "==========================================================" ;

	gdalImage dem_img(in_dem_path);
	gdalImage lonlat(in_gec_lon_lat_path);
	gdalImage incident_angle = CreategdalImage(out_incident_angle_path, this->pstn.height, this->pstn.width, 1, dem_img.gt, dem_img.projection, false);
	gdalImage local_incident_angle = CreategdalImage(out_local_incident_angle_path, this->pstn.height, this->pstn.width, 1, dem_img.gt, dem_img.projection, false);
	// ʼ
	{
		dem_img.InitInv_gt();
		int line_invert = int(500000 / this->pstn.width);
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		do {
			Eigen::MatrixXd	sar_inc = incident_angle.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_local_incident = local_incident_angle.getData(start_ids, 0, line_invert, this->pstn.width, 1);

			sar_inc = sar_inc.array() * 0;
			sar_local_incident = sar_local_incident.array() * 0;

			incident_angle.saveImage(sar_inc, start_ids, 0, 1);
			local_incident_angle.saveImage(sar_local_incident, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < this->pstn.height);
	}

	{
		double PRF = this->pstn.PRF;
		double imgstarttime = this->pstn.imgStartTime;

		int line_invert = 500;
		int start_ids = 0;
		int line_cound_sum = 0;
		omp_lock_t lock;
		omp_init_lock(&lock); // ʼ

		for (start_ids = 0; start_ids < this->pstn.height; start_ids = start_ids + line_invert) {
			Eigen::MatrixXd	lon = lonlat.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	lat = lonlat.getData(start_ids, 0, line_invert, this->pstn.width, 2);
			Eigen::MatrixXd dem_col = dem_img.inv_gt(0, 0) + dem_img.inv_gt(0, 1) * lon.array() + dem_img.inv_gt(0, 2) * lat.array();
			Eigen::MatrixXd dem_row = dem_img.inv_gt(1, 0) + dem_img.inv_gt(1, 1) * lon.array() + dem_img.inv_gt(1, 2) * lat.array();
			//lon = Eigen::MatrixXd::Ones(1,1);
			//lat= Eigen::MatrixXd::Ones(1,1);
			int min_row = floor(dem_row.array().minCoeff());
			int max_row = ceil(dem_row.array().maxCoeff());
			min_row = min_row - 1 >= 0 ? min_row - 1 : 0;
			max_row = max_row + 1 < dem_img.height ? max_row + 1 : dem_img.height;
			int row_len = max_row - min_row + 1;
			Eigen::MatrixXd dem = dem_img.getData(min_row, 0, row_len, dem_img.width, 1);

			Eigen::MatrixXd	sar_inc = incident_angle.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			Eigen::MatrixXd	sar_local_incident = local_incident_angle.getData(start_ids, 0, line_invert, this->pstn.width, 1);
			int min_col = 0;
			int lon_row_count = dem_col.rows();
			int lon_col_count = dem_col.cols();
#pragma omp parallel for num_threads(8) // NEW ADD
			for (int i = 0; i < lon_row_count; i++)
			{
				Landpoint p0, p1, p2, p3, p4, slopeVector, landpoint, satepoint;
				double localincangle, inc_angle;
				// ͬһУһ
				long double satatime = (i + start_ids) * (1 / PRF) + imgstarttime;
				Eigen::MatrixXd sataState = this->pstn.orbit.SatelliteSpacePoint(satatime);
				satepoint = Landpoint{ sataState(0,0),sataState(0,1) ,sataState(0,2) };
				double dem_r, dem_c;
				int r0, r1;
				int c0, c1;
				for (int j = 0; j < lon_col_count; j++) {
					// к
					dem_r = dem_row(i, j); //y
					dem_c = dem_col(i, j); // x
					r0 = floor(dem_r);
					r1 = ceil(dem_r);
					c0 = floor(dem_c);
					c1 = ceil(dem_c);

					p0 = Landpoint{ dem_c - c0,dem_r - r0,0 };
					p1 = Landpoint{ 0,0,dem(r0 - min_row, c0 - min_col) }; // p11(0,0)
					p2 = Landpoint{ 0,1,dem(r0 - min_row + 1, c0 - min_col) }; // p21(0,1)
					p3 = Landpoint{ 1,0,dem(r0 - min_row , c0 + 1 - min_col) }; // p12(1,0)
					p4 = Landpoint{ 1,1,dem(r0 - min_row + 1, c0 + 1 - min_col) }; // p22(1,1)
					p0.ati = Bilinear_interpolation(p0, p1, p2, p3, p4);

					p0 = dem_img.getLandPoint(dem_r, dem_c, p0.ati); // 
					p1 = dem_img.getLandPoint(r0, c0, dem(r0 - min_row, c0 - min_col)); // p11(0,0)
					p2 = dem_img.getLandPoint(r1, c0, dem(r1 - min_row, c0 - min_col)); // p21(0,1)
					p3 = dem_img.getLandPoint(r0, c1, dem(r0 - min_row, c1 - min_col)); // p12(1,0)
					p4 = dem_img.getLandPoint(r1, c1, dem(r1 - min_row, c1 - min_col)); // p22(1,1)

					slopeVector = getSlopeVector(p0, p1, p2, p3, p4); // ʸ
					landpoint = LLA2XYZ(p0);
					localincangle = getlocalIncAngle(satepoint, landpoint, slopeVector);// ֵ
					inc_angle = getIncAngle(satepoint, landpoint); // ӽ

					// ¼ֵ
					sar_local_incident(i, j) = localincangle;
					sar_inc(i, j) = inc_angle;
				}
			}
			omp_set_lock(&lock);
			incident_angle.saveImage(sar_inc, start_ids, 0, 1);
			local_incident_angle.saveImage(sar_local_incident, start_ids, 0, 1);
			line_cound_sum = line_cound_sum + line_invert;
			qDebug() << "rows:\t" << start_ids << "\t" << line_cound_sum << "/" << this->pstn.height << "\t computing.....\t" << getCurrentTimeString() ;
			omp_unset_lock(&lock);
		}
		omp_destroy_lock(&lock); //ٻ
	}


	qDebug() << "computer Incident_localIncident_angle in sar,      overing:\t" << getCurrentTimeString() ;
}

/// <summary>
/// ֵGTCӰֵ
/// </summary>
/// <param name="in_rc_wgs84_path"></param>
/// <param name="in_ori_sar_path"></param>
/// <param name="out_orth_sar_path"></param>
/// <param name="PSTN"></param>
void simProcess::interpolation_GTC_sar(QString in_rc_wgs84_path, QString in_ori_sar_path, QString out_orth_sar_path, PSTNAlgorithm pstn)
{
	qDebug() << "interpolation(cubic convolution) orth sar value by rc_wgs84 and ori_sar image and model, begin time:" << getCurrentTimeString() ;


	gdalImage sar_rc(in_rc_wgs84_path);
	gdalImage ori_sar(in_ori_sar_path);
	gdalImage sar_img = CreategdalImage(out_orth_sar_path, sar_rc.height, sar_rc.width, 2, sar_rc.gt, sar_rc.projection);

	// ʼ
	{
		sar_rc.InitInv_gt();
		int line_invert = 100;
		int start_ids = 0;
		do {
			Eigen::MatrixXd	sar_a = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			Eigen::MatrixXd	sar_b = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 2);

			sar_a = sar_a.array() * 0 - 9999;
			sar_b = sar_b.array() * 0 - 9999;

			sar_img.saveImage(sar_a, start_ids, 0, 1);
			sar_img.saveImage(sar_a, start_ids, 0, 2);
			start_ids = start_ids + line_invert;
		} while (start_ids < sar_rc.height);
		sar_img.setNoDataValue(-9999, 1);
		sar_img.setNoDataValue(-9999, 2);
	}

	// ʽֵ
	{
		int line_invert = 500;
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		do {

			qDebug() << "rows:\t" << start_ids << "/" << sar_rc.height << "\t computing.....\t" << getCurrentTimeString() ;
			Eigen::MatrixXd	sar_r = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			Eigen::MatrixXd	sar_c = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 2);

			// кŻȡΧ
			int min_r = floor(sar_r.array().minCoeff());
			int max_r = ceil(sar_r.array().maxCoeff());
			int min_c = floor(sar_c.array().minCoeff());
			int max_c = ceil(sar_c.array().maxCoeff());

			if (max_r < 0 || max_c < 0 || min_r >= this->pstn.height || min_c >= this->pstn.width) {
				start_ids = start_ids + line_invert;
				if (start_ids < sar_rc.height) {
					continue;
				}
				else {
					break;
				}
			}

			min_r = min_r >= 0 ? min_r : 0;
			max_r = max_r < this->pstn.height ? max_r : this->pstn.height;
			min_c = min_c >= 0 ? min_c : 0;
			max_c = max_c < this->pstn.width ? max_c : this->pstn.width;

			// ȡӰ
			int len_row = max_r - min_r + 4;
			Eigen::MatrixXd	ori_a = ori_sar.getData(min_r, 0, len_row, this->pstn.width, 1);
			Eigen::MatrixXd	ori_b = ori_sar.getData(min_r, 0, len_row, this->pstn.width, 2);
			int row_count = ori_a.rows();
			int col_count = ori_a.cols();

			Eigen::MatrixX<complex<double>> ori(ori_a.rows(), ori_a.cols());
			for (int i = 0; i < row_count; i++) {
				for (int j = 0; j < col_count; j++) {
					ori(i, j) = complex<double>{ ori_a(i, j), ori_b(i, j) };
				}
			}
			ori_a = Eigen::MatrixXd(1, 1);
			ori_b = Eigen::MatrixXd(1, 1); // ͷڴ
			Eigen::MatrixXd	sar_a = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			Eigen::MatrixXd	sar_b = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 2);
			sar_r = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			sar_c = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 2);
			row_count = sar_r.rows();
			col_count = sar_r.cols();
#pragma omp parallel for num_threads(8) // NEW ADD
			for (int i = 0; i < row_count; i++) {
				int r0, r1, r2, r3, c0, c1, c2, c3;
				double r, c;
				for (int j = 0; j < col_count; j++) {
					r = sar_r(i, j);
					c = sar_c(i, j);
					if (r < 0 || c < 0 || r >= this->pstn.height || c >= this->pstn.width) {
						continue;
					}
					else {
						int kkkkk = 0;

					}
					r1 = floor(r);
					r0 = r1 - 1; r2 = r1 + 1; r3 = r1 + 2; // ȡ
					c1 = floor(c);
					c0 = c1 - 1; c2 = c1 + 1; c3 = c1 + 2; // ȡ
					// Ǳ߽
					if (r0<-1 || c0<-1 || c3>this->pstn.width || r3>this->pstn.height) {
						continue;
					}
					// ֵ߽㣬ֵģȨ
					Eigen::MatrixX<complex<double>> img_block(4, 4);
					if (r0 == -1 || c0 == -1) {
						if (r0 == -1) {
							if (c0 == -1) {
								img_block(3, 3) = ori(r3 - min_r, c3);
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 0) = ori(r3 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r3 - min_r, c2) + ori(r3 - min_r, c3); // k,-1

								img_block(2, 3) = ori(r2 - min_r, c3);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 0) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r2 - min_r, c3); // k,-1

								img_block(1, 3) = ori(r1 - min_r, c3);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 0) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r1 - min_r, c3); // k,-1

								img_block(0, 3) = ori(r1 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c3) + ori(r3 - min_r, c3);//-1,k
								img_block(0, 2) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r3 - min_r, c2);//-1,
								img_block(0, 1) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r3 - min_r, c1);//-1,
								img_block(0, 0) = img_block(1, 0) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(2, 0) + img_block(3, 0);// -1,-1
							}
							else if (c3 == this->pstn.width) {
								img_block(3, 3) = ori(r3 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r3 - min_r, c1) + ori(r3 - min_r, c0);//2,M+1
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 0) = ori(r3 - min_r, c0);//j,M-2

								img_block(2, 3) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r2 - min_r, c0);//1,M+1
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 0) = ori(r2 - min_r, c0);//j,M-2

								img_block(1, 3) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r1 - min_r, c0);//0,M+1
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 0) = ori(r1 - min_r, c0);//j,M-2

								img_block(0, 3) = img_block(2, 3) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(2, 3) + img_block(3, 3);//-1,M+1
								img_block(0, 2) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r3 - min_r, c2);//-1,
								img_block(0, 1) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r3 - min_r, c1);//-1,
								img_block(0, 0) = ori(r1 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c0) + ori(r3 - min_r, c0);//-1,k
							}
							else {
								img_block(3, 3) = ori(r3 - min_r, c3);
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 0) = ori(r3 - min_r, c0);

								img_block(2, 3) = ori(r2 - min_r, c3);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 0) = ori(r2 - min_r, c0);

								img_block(1, 3) = ori(r1 - min_r, c3);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 0) = ori(r1 - min_r, c0);

								img_block(0, 3) = ori(r1 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c3) + ori(r3 - min_r, c3);//-1,k
								img_block(0, 2) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r3 - min_r, c2);//-1
								img_block(0, 1) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r3 - min_r, c1);//-1
								img_block(0, 0) = ori(r1 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c0) + ori(r3 - min_r, c0);//-1
							}

						}

						else if (c0 == -1)//r0 != -1
						{
							if (r3 == this->pstn.height) {
								img_block(0, 0) = ori(r0 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c2) + ori(r0 - min_r, c3);//j,-1
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c3);

								img_block(1, 0) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r1 - min_r, c3);//j,-1
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c3);

								img_block(2, 0) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r2 - min_r, c3);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c3);

								img_block(3, 0) = img_block(2, 0) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(1, 0) + img_block(0, 0);//N+1,-1
								img_block(3, 1) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r0 - min_r, c1);//N+1,j
								img_block(3, 2) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r0 - min_r, c2);//N+1,j
								img_block(3, 3) = ori(r2 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c3) + ori(r0 - min_r, c3);//N+1,j
							}
							else { // 
								img_block(0, 0) = ori(r0 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c2) + ori(r0 - min_r, c3);//j,-1
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c3);

								img_block(1, 0) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r1 - min_r, c3);//j,-1
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c3);

								img_block(2, 0) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r2 - min_r, c3);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c3);

								img_block(3, 0) = img_block(2, 0) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(1, 0) + img_block(0, 0);//N+1,-1
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 3) = ori(r3 - min_r, c3);
							}
						}

					}
					else if (r3 == this->pstn.height || c3 == this->pstn.width) {
						if (r3 == this->pstn.height) {
							if (c3 == this->pstn.width) {
								img_block(0, 0) = ori(r0 - min_r, c0);
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c1) + ori(r0 - min_r, c0);;//j,M+1

								img_block(1, 0) = ori(r1 - min_r, c0);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r1 - min_r, c0);;//j,M+1

								img_block(2, 0) = ori(r2 - min_r, c0);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r2 - min_r, c0);;//j,M+1

								img_block(3, 0) = ori(r2 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c0) + ori(r0 - min_r, c0);//N+1,-1
								img_block(3, 1) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r0 - min_r, c1);//N+1,j
								img_block(3, 2) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r0 - min_r, c2);//N+1,j
								img_block(3, 3) = img_block(2, 3) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(1, 3) + img_block(0, 3);//N+1,M+1

							}
							else {
								img_block(0, 0) = ori(r0 - min_r, c0);
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c3);//j,M+1

								img_block(1, 0) = ori(r1 - min_r, c0);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c3);//j,M+1

								img_block(2, 0) = ori(r2 - min_r, c0);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c3);//j,M+1

								img_block(3, 0) = ori(r2 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c0) + ori(r0 - min_r, c0);//N+1,-1
								img_block(3, 1) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r0 - min_r, c1);//N+1,j
								img_block(3, 2) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r0 - min_r, c2);//N+1,j
								img_block(3, 3) = ori(r2 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c3) + ori(r0 - min_r, c3);//N+1,j
							}
						}
						else if (c3 == this->pstn.width) { // r3 != this->pstn.height
							img_block(3, 3) = ori(r3 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r3 - min_r, c1) + ori(r3 - min_r, c0);//2,M+1
							img_block(3, 2) = ori(r3 - min_r, c2);
							img_block(3, 1) = ori(r3 - min_r, c1);
							img_block(3, 0) = ori(r3 - min_r, c0);//j,M-2

							img_block(2, 3) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r2 - min_r, c0);//1,M+1
							img_block(2, 2) = ori(r2 - min_r, c2);
							img_block(2, 1) = ori(r2 - min_r, c1);
							img_block(2, 0) = ori(r2 - min_r, c0);//j,M-2

							img_block(1, 3) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r1 - min_r, c0);//0,M+1
							img_block(1, 2) = ori(r1 - min_r, c2);
							img_block(1, 1) = ori(r1 - min_r, c1);
							img_block(1, 0) = ori(r1 - min_r, c0);//j,M-2

							img_block(0, 3) = ori(r0 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c1) + ori(r0 - min_r, c0);//0,M+1
							img_block(0, 2) = ori(r0 - min_r, c2);
							img_block(0, 1) = ori(r0 - min_r, c1);
							img_block(0, 0) = ori(r0 - min_r, c0);
						}
					}
					else {
						img_block(3, 3) = ori(r3 - min_r, c3);
						img_block(3, 2) = ori(r3 - min_r, c2);
						img_block(3, 1) = ori(r3 - min_r, c1);
						img_block(3, 0) = ori(r3 - min_r, c0);

						img_block(2, 3) = ori(r2 - min_r, c3);
						img_block(2, 2) = ori(r2 - min_r, c2);
						img_block(2, 1) = ori(r2 - min_r, c1);
						img_block(2, 0) = ori(r2 - min_r, c0);

						img_block(1, 3) = ori(r1 - min_r, c3);
						img_block(1, 2) = ori(r1 - min_r, c2);
						img_block(1, 1) = ori(r1 - min_r, c1);
						img_block(1, 0) = ori(r1 - min_r, c0);

						img_block(0, 3) = ori(r0 - min_r, c3);
						img_block(0, 2) = ori(r0 - min_r, c2);
						img_block(0, 1) = ori(r0 - min_r, c1);
						img_block(0, 0) = ori(r0 - min_r, c0);
					}

					complex<double> interpolation_value = Cubic_Convolution_interpolation(r - r1, c - c1, img_block);
					// 
					sar_a(i, j) = interpolation_value.real();
					sar_b(i, j) = interpolation_value.imag();
				}
			}
			sar_img.saveImage(sar_a, start_ids, 0, 1);
			sar_img.saveImage(sar_b, start_ids, 0, 2);
			start_ids = start_ids + line_invert;
		} while (start_ids < sar_rc.height);
	}
	qDebug() << "interpolation(cubic convolution) orth sar value by rc_wgs84 and ori_sar image and model,  over:\t" << getCurrentTimeString() ;
}


/// <summary>
/// ֵGTCӰֵ
/// </summary>
/// <param name="in_rc_wgs84_path"></param>
/// <param name="in_ori_sar_path"></param>
/// <param name="out_orth_sar_path"></param>
/// <param name="PSTN"></param>
void simProcess::interpolation_GTC_sar_sigma(QString in_rc_wgs84_path, QString in_ori_sar_path, QString out_orth_sar_path, PSTNAlgorithm pstn)
{
	qDebug() << "interpolation(cubic convolution) orth sar value by rc_wgs84 and ori_sar image and model, begin time:" << getCurrentTimeString() ;
	gdalImage sar_rc(in_rc_wgs84_path);
	gdalImage ori_sar(in_ori_sar_path);
	gdalImage sar_img = CreategdalImage(out_orth_sar_path, sar_rc.height, sar_rc.width, 1, sar_rc.gt, sar_rc.projection);

	// ʼ
	{
		sar_rc.InitInv_gt();
		int line_invert = 100;
		int start_ids = 0;
		do {
			Eigen::MatrixXd	sar_a = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			Eigen::MatrixXd	sar_b = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 2);

			sar_a = sar_a.array() * 0 - 9999;
			sar_b = sar_b.array() * 0 - 9999;

			sar_img.saveImage(sar_a, start_ids, 0, 1);
			sar_img.saveImage(sar_a, start_ids, 0, 2);
			start_ids = start_ids + line_invert;
		} while (start_ids < sar_rc.height);
		sar_img.setNoDataValue(-9999, 1);
		sar_img.setNoDataValue(-9999, 2);
	}

	// ʽֵ
	{
		int line_invert = 500;
		line_invert = line_invert > 10 ? line_invert : 10;
		int start_ids = 0;
		do {

			qDebug() << "rows:\t" << start_ids << "/" << sar_rc.height << "\t computing.....\t" << getCurrentTimeString() ;
			Eigen::MatrixXd	sar_r = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			Eigen::MatrixXd	sar_c = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 2);

			// кŻȡΧ
			int min_r = floor(sar_r.array().minCoeff());
			int max_r = ceil(sar_r.array().maxCoeff());
			int min_c = floor(sar_c.array().minCoeff());
			int max_c = ceil(sar_c.array().maxCoeff());

			if (max_r < 0 || max_c < 0 || min_r >= this->pstn.height || min_c >= this->pstn.width) {
				start_ids = start_ids + line_invert;
				if (start_ids < sar_rc.height) {
					continue;
				}
				else {
					break;
				}
			}

			min_r = min_r >= 0 ? min_r : 0;
			max_r = max_r < this->pstn.height ? max_r : this->pstn.height;
			min_c = min_c >= 0 ? min_c : 0;
			max_c = max_c < this->pstn.width ? max_c : this->pstn.width;

			// ȡӰ
			int len_row = max_r - min_r + 4;
			Eigen::MatrixXd	ori_a = ori_sar.getData(min_r, 0, len_row, this->pstn.width, 1);
			//Eigen::MatrixXd	ori_b = ori_sar.getData(min_r, 0, len_row, this->pstn.width, 2);
			int row_count = ori_a.rows();
			int col_count = ori_a.cols();

			Eigen::MatrixX<complex<double>> ori(ori_a.rows(), ori_a.cols());
			for (int i = 0; i < row_count; i++) {
				for (int j = 0; j < col_count; j++) {
					ori(i, j) = complex<double>{ ori_a(i, j), 0 };
				}
			}
			ori_a = Eigen::MatrixXd(1, 1);
			//ori_b = Eigen::MatrixXd(1, 1); // ͷڴ
			Eigen::MatrixXd	sar_a = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			Eigen::MatrixXd	sar_b = sar_img.getData(start_ids, 0, line_invert, sar_rc.width, 2);
			sar_r = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 1);
			sar_c = sar_rc.getData(start_ids, 0, line_invert, sar_rc.width, 2);
			row_count = sar_r.rows();
			col_count = sar_r.cols();
#pragma omp parallel for num_threads(8) // NEW ADD
			for (int i = 0; i < row_count; i++) {
				int r0, r1, r2, r3, c0, c1, c2, c3;
				double r, c;
				for (int j = 0; j < col_count; j++) {
					r = sar_r(i, j);
					c = sar_c(i, j);
					if (r < 0 || c < 0 || r >= this->pstn.height || c >= this->pstn.width) {
						continue;
					}
					else {
						int kkkkk = 0;

					}
					r1 = floor(r);
					r0 = r1 - 1; r2 = r1 + 1; r3 = r1 + 2; // ȡ
					c1 = floor(c);
					c0 = c1 - 1; c2 = c1 + 1; c3 = c1 + 2; // ȡ
					// Ǳ߽
					if (r0<-1 || c0<-1 || c3>this->pstn.width || r3>this->pstn.height) {
						continue;
					}
					// ֵ߽㣬ֵģȨ
					Eigen::MatrixX<complex<double>> img_block(4, 4);
					if (r0 == -1 || c0 == -1) {
						if (r0 == -1) {
							if (c0 == -1) {
								img_block(3, 3) = ori(r3 - min_r, c3);
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 0) = ori(r3 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r3 - min_r, c2) + ori(r3 - min_r, c3); // k,-1

								img_block(2, 3) = ori(r2 - min_r, c3);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 0) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r2 - min_r, c3); // k,-1

								img_block(1, 3) = ori(r1 - min_r, c3);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 0) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r1 - min_r, c3); // k,-1

								img_block(0, 3) = ori(r1 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c3) + ori(r3 - min_r, c3);//-1,k
								img_block(0, 2) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r3 - min_r, c2);//-1,
								img_block(0, 1) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r3 - min_r, c1);//-1,
								img_block(0, 0) = img_block(1, 0) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(2, 0) + img_block(3, 0);// -1,-1
							}
							else if (c3 == this->pstn.width) {
								img_block(3, 3) = ori(r3 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r3 - min_r, c1) + ori(r3 - min_r, c0);//2,M+1
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 0) = ori(r3 - min_r, c0);//j,M-2

								img_block(2, 3) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r2 - min_r, c0);//1,M+1
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 0) = ori(r2 - min_r, c0);//j,M-2

								img_block(1, 3) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r1 - min_r, c0);//0,M+1
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 0) = ori(r1 - min_r, c0);//j,M-2

								img_block(0, 3) = img_block(2, 3) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(2, 3) + img_block(3, 3);//-1,M+1
								img_block(0, 2) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r3 - min_r, c2);//-1,
								img_block(0, 1) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r3 - min_r, c1);//-1,
								img_block(0, 0) = ori(r1 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c0) + ori(r3 - min_r, c0);//-1,k
							}
							else {
								img_block(3, 3) = ori(r3 - min_r, c3);
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 0) = ori(r3 - min_r, c0);

								img_block(2, 3) = ori(r2 - min_r, c3);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 0) = ori(r2 - min_r, c0);

								img_block(1, 3) = ori(r1 - min_r, c3);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 0) = ori(r1 - min_r, c0);

								img_block(0, 3) = ori(r1 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c3) + ori(r3 - min_r, c3);//-1,k
								img_block(0, 2) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r3 - min_r, c2);//-1
								img_block(0, 1) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r3 - min_r, c1);//-1
								img_block(0, 0) = ori(r1 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c0) + ori(r3 - min_r, c0);//-1
							}

						}

						else if (c0 == -1)//r0 != -1
						{
							if (r3 == this->pstn.height) {
								img_block(0, 0) = ori(r0 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c2) + ori(r0 - min_r, c3);//j,-1
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c3);

								img_block(1, 0) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r1 - min_r, c3);//j,-1
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c3);

								img_block(2, 0) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r2 - min_r, c3);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c3);

								img_block(3, 0) = img_block(2, 0) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(1, 0) + img_block(0, 0);//N+1,-1
								img_block(3, 1) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r0 - min_r, c1);//N+1,j
								img_block(3, 2) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r0 - min_r, c2);//N+1,j
								img_block(3, 3) = ori(r2 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c3) + ori(r0 - min_r, c3);//N+1,j
							}
							else { // 
								img_block(0, 0) = ori(r0 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c2) + ori(r0 - min_r, c3);//j,-1
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c3);

								img_block(1, 0) = ori(r1 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r1 - min_r, c3);//j,-1
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c3);

								img_block(2, 0) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c2) + ori(r2 - min_r, c3);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c3);

								img_block(3, 0) = img_block(2, 0) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(1, 0) + img_block(0, 0);//N+1,-1
								img_block(3, 1) = ori(r3 - min_r, c1);
								img_block(3, 2) = ori(r3 - min_r, c2);
								img_block(3, 3) = ori(r3 - min_r, c3);
							}
						}

					}
					else if (r3 == this->pstn.height || c3 == this->pstn.width) {
						if (r3 == this->pstn.height) {
							if (c3 == this->pstn.width) {
								img_block(0, 0) = ori(r0 - min_r, c0);
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c1) + ori(r0 - min_r, c0);;//j,M+1

								img_block(1, 0) = ori(r1 - min_r, c0);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r1 - min_r, c0);;//j,M+1

								img_block(2, 0) = ori(r2 - min_r, c0);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r2 - min_r, c0);;//j,M+1

								img_block(3, 0) = ori(r2 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c0) + ori(r0 - min_r, c0);//N+1,-1
								img_block(3, 1) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r0 - min_r, c1);//N+1,j
								img_block(3, 2) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r0 - min_r, c2);//N+1,j
								img_block(3, 3) = img_block(2, 3) * complex<double>{3, 0} - complex<double>{3, 0} *img_block(1, 3) + img_block(0, 3);//N+1,M+1

							}
							else {
								img_block(0, 0) = ori(r0 - min_r, c0);
								img_block(0, 1) = ori(r0 - min_r, c1);
								img_block(0, 2) = ori(r0 - min_r, c2);
								img_block(0, 3) = ori(r0 - min_r, c3);//j,M+1

								img_block(1, 0) = ori(r1 - min_r, c0);
								img_block(1, 1) = ori(r1 - min_r, c1);
								img_block(1, 2) = ori(r1 - min_r, c2);
								img_block(1, 3) = ori(r1 - min_r, c3);//j,M+1

								img_block(2, 0) = ori(r2 - min_r, c0);//j,-1
								img_block(2, 1) = ori(r2 - min_r, c1);
								img_block(2, 2) = ori(r2 - min_r, c2);
								img_block(2, 3) = ori(r2 - min_r, c3);//j,M+1

								img_block(3, 0) = ori(r2 - min_r, c0) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c0) + ori(r0 - min_r, c0);//N+1,-1
								img_block(3, 1) = ori(r2 - min_r, c1) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r0 - min_r, c1);//N+1,j
								img_block(3, 2) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c2) + ori(r0 - min_r, c2);//N+1,j
								img_block(3, 3) = ori(r2 - min_r, c3) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c3) + ori(r0 - min_r, c3);//N+1,j
							}
						}
						else if (c3 == this->pstn.width) { // r3 != this->pstn.height
							img_block(3, 3) = ori(r3 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r3 - min_r, c1) + ori(r3 - min_r, c0);//2,M+1
							img_block(3, 2) = ori(r3 - min_r, c2);
							img_block(3, 1) = ori(r3 - min_r, c1);
							img_block(3, 0) = ori(r3 - min_r, c0);//j,M-2

							img_block(2, 3) = ori(r2 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r2 - min_r, c1) + ori(r2 - min_r, c0);//1,M+1
							img_block(2, 2) = ori(r2 - min_r, c2);
							img_block(2, 1) = ori(r2 - min_r, c1);
							img_block(2, 0) = ori(r2 - min_r, c0);//j,M-2

							img_block(1, 3) = ori(r1 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r1 - min_r, c1) + ori(r1 - min_r, c0);//0,M+1
							img_block(1, 2) = ori(r1 - min_r, c2);
							img_block(1, 1) = ori(r1 - min_r, c1);
							img_block(1, 0) = ori(r1 - min_r, c0);//j,M-2

							img_block(0, 3) = ori(r0 - min_r, c2) * complex<double>{3, 0} - complex<double>{3, 0} *ori(r0 - min_r, c1) + ori(r0 - min_r, c0);//0,M+1
							img_block(0, 2) = ori(r0 - min_r, c2);
							img_block(0, 1) = ori(r0 - min_r, c1);
							img_block(0, 0) = ori(r0 - min_r, c0);
						}
					}
					else {
						img_block(3, 3) = ori(r3 - min_r, c3);
						img_block(3, 2) = ori(r3 - min_r, c2);
						img_block(3, 1) = ori(r3 - min_r, c1);
						img_block(3, 0) = ori(r3 - min_r, c0);

						img_block(2, 3) = ori(r2 - min_r, c3);
						img_block(2, 2) = ori(r2 - min_r, c2);
						img_block(2, 1) = ori(r2 - min_r, c1);
						img_block(2, 0) = ori(r2 - min_r, c0);

						img_block(1, 3) = ori(r1 - min_r, c3);
						img_block(1, 2) = ori(r1 - min_r, c2);
						img_block(1, 1) = ori(r1 - min_r, c1);
						img_block(1, 0) = ori(r1 - min_r, c0);

						img_block(0, 3) = ori(r0 - min_r, c3);
						img_block(0, 2) = ori(r0 - min_r, c2);
						img_block(0, 1) = ori(r0 - min_r, c1);
						img_block(0, 0) = ori(r0 - min_r, c0);
					}

					complex<double> interpolation_value = Cubic_Convolution_interpolation(r - r1, c - c1, img_block);
					// 
					sar_a(i, j) = interpolation_value.real();
					sar_b(i, j) = interpolation_value.imag();
				}
			}
			sar_img.saveImage(sar_a, start_ids, 0, 1);
			sar_img.saveImage(sar_b, start_ids, 0, 2);
			start_ids = start_ids + line_invert;
		} while (start_ids < sar_rc.height);
	}
	qDebug() << "interpolation(cubic convolution) orth sar value by rc_wgs84 and ori_sar image and model,  over:\t" << getCurrentTimeString() ;
}



/// <summary>
/// RPCкţRPCӦDEMļ
/// </summary>
/// <param name="in_rpc_rc_path"></param>
/// <param name="in_dem_path"></param>
/// <param name="out_rpc_dem_path"></param>
void simProcess::CreateRPC_DEM(QString in_rpc_rc_path, QString in_dem_path, QString out_rpc_dem_path)
{
	gdalImage rpc_rc(in_rpc_rc_path);
	gdalImage dem_img(in_dem_path);
	gdalImage rpc_dem_img = CreategdalImage(out_rpc_dem_path, rpc_rc.height, rpc_rc.width, 1, rpc_rc.gt, rpc_rc.projection);

	// ʼ
	{
		dem_img.InitInv_gt();
		int line_invert = 100;
		int start_ids = 0;
		do {
			Eigen::MatrixXd	rpc_dem = rpc_dem_img.getData(start_ids, 0, line_invert, rpc_dem_img.width, 1);
			rpc_dem = rpc_dem.array() * 0 - 9999;
			rpc_dem_img.saveImage(rpc_dem, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < rpc_dem_img.height);
		rpc_dem_img.setNoDataValue(-9999, 1);
	}

	// ֵ
	{
		dem_img.InitInv_gt();
		int line_invert = 100;
		int start_ids = 0;
		do {

			qDebug() << "rows:\t" << start_ids << "/" << rpc_dem_img.height << "\t computing.....\t" << getCurrentTimeString() ;
			Eigen::MatrixXd	rpc_dem = rpc_dem_img.getData(start_ids, 0, line_invert, rpc_dem_img.width, 1);
			Eigen::MatrixXd rpc_row = rpc_dem.array() * 0 - 1;
			Eigen::MatrixXd rpc_col = rpc_dem.array() * 0 - 1;
			int row_count = rpc_dem.rows();
			int col_count = rpc_dem.cols();
			for (int i = 0; i < row_count; i++) {
				for (int j = 0; j < col_count; j++) {
					Landpoint landpoint = rpc_dem_img.getLandPoint(i + start_ids, j, 0);
					Landpoint land_row_col = dem_img.getRow_Col(landpoint.lon, landpoint.lat); // x,y,z
					rpc_row(i, j) = land_row_col.lat; // row
					rpc_col(i, j) = land_row_col.lon; // col
				}
			}

			double min_r = floor(rpc_row.minCoeff()) - 1;
			double max_r = ceil(rpc_row.maxCoeff()) + 1;
			min_r = min_r >= 0 ? min_r : 0;
			int len_r = max_r - min_r;
			Eigen::MatrixXd dem = dem_img.getData(min_r, 0, len_r + 2, dem_img.width, 1);

			for (int i = 0; i < row_count; i++) {
				for (int j = 0; j < col_count; j++) {
					Landpoint p0 = Landpoint{ rpc_row(i,j),rpc_col(i,j),0 };
					Landpoint p1 = Landpoint{ floor(p0.lon),floor(p0.lat),0 }; p1.ati = dem(int(p1.lon - min_r), int(p1.lat)); p1 = Landpoint{ 0,0,p1.ati };
					Landpoint p2 = Landpoint{ floor(p0.lon),ceil(p0.lat),0 }; p2.ati = dem(int(p2.lon - min_r), int(p2.lat)); p2 = Landpoint{ 0,1,p2.ati };
					Landpoint p3 = Landpoint{ ceil(p0.lon),floor(p0.lat),0 }; p3.ati = dem(int(p3.lon - min_r), int(p3.lat)); p3 = Landpoint{ 1,0,p3.ati };
					Landpoint p4 = Landpoint{ ceil(p0.lon),ceil(p0.lat),0 }; p4.ati = dem(int(p4.lon - min_r), int(p4.lat)); p4 = Landpoint{ 1,1,p4.ati };
					p0 = Landpoint{ p0.lon - floor(p0.lon), p0.lat - floor(p0.lat), 0 };
					p0.ati = Bilinear_interpolation(p0, p1, p2, p3, p4);
					rpc_dem(i, j) = p0.ati;
				}
			}
			rpc_dem_img.saveImage(rpc_dem, start_ids, 0, 1);
			start_ids = start_ids + line_invert;
		} while (start_ids < rpc_dem_img.height);
	}


}

void simProcess::CreateRPC_refrenceTable(QString in_rpc_tiff_path, QString in_merge_dem,QString out_rpc_lon_lat_tiff_path)
{
	CPLSetConfigOption("GDAL_FILENAME_IS_UTF8", "NO");
	CPLSetConfigOption("GDAL_DATA", "./data");
	GDALAllRegister();//ע

	const char* pszTif = in_rpc_tiff_path.toUtf8().constData();

	gdalImage rpc_img(in_rpc_tiff_path);

	GDALRPCInfo oInfo = rpc_img.getRPC();

	//RPCģDEM·
	char** papszTransOption = NULL;
	//papszTransOption = CSLSetNameValue(papszTransOption, "RPC_DEM", "E:\\DEM.img");   //DEM

	//ʹRPCϢDEMȹRPCת
	void* pRPCTransform = GDALCreateRPCTransformer(&oInfo, FALSE, 0, papszTransOption);


	// Ӱ

	gdalImage lon_lat_img = CreategdalImage(out_rpc_lon_lat_tiff_path, rpc_img.height, rpc_img.width, 2, rpc_img.gt, rpc_img.projection, false);
	// ǵ
	QString temp_dem_path = in_merge_dem + ".bak";
	double merge_gt[6] = {
		rpc_img.gt(0,0), rpc_img.gt(0,1), rpc_img.gt(0,2),
		rpc_img.gt(0,3), rpc_img.gt(0,4), rpc_img.gt(0,5)
	}	;
	ResampleGDAL(in_merge_dem.toUtf8().constData(), temp_dem_path.toUtf8().constData(), merge_gt, rpc_img.width, rpc_img.height, GRA_Bilinear);

	gdalImage merger_dem_tiff(temp_dem_path);
	double X[4] = { 0,0,rpc_img.width - 1,rpc_img.width - 1 };
	double Y[4] = { 0,rpc_img.height - 1,rpc_img.height - 1,0 };
	double Z[4] = { 0,0,0,0 };
	int sucess_num[4] = { false,false,false,false };
	GDALRPCTransform(pRPCTransform, FALSE, 4, X, Y, Z, sucess_num);
	for (int i = 0; i < 4; i++) {
		qDebug() << X[i] << "\t" << Y[i] << "\t" << Z[i] << "\t" << sucess_num[i] ;
	}
	int line_invert = int(1500000 / rpc_img.width);
	line_invert = line_invert > 10 ? line_invert : 10;
	int count_lines = 0;
	omp_lock_t lock;
	omp_init_lock(&lock); // ʼ
#pragma omp parallel for num_threads(6) // NEW ADD
	for (int max_rows_ids = 0; max_rows_ids < lon_lat_img.height; max_rows_ids = max_rows_ids + line_invert) {
		//line_invert = dem_clip.height - max_rows_ids > line_invert ? line_invert : dem_clip.height - max_rows_ids;

		Eigen::MatrixXd lon = lon_lat_img.getData(max_rows_ids, 0, line_invert, lon_lat_img.width, 1);
		Eigen::MatrixXd lat = lon_lat_img.getData(max_rows_ids, 0, line_invert, lon_lat_img.width, 2);
		Eigen::MatrixXd dem = merger_dem_tiff.getData(max_rows_ids, 0, line_invert, lon_lat_img.width, 2);
		int row_count = lon.rows();
		int col_count = lon.cols();
		for (int i = 0; i < row_count; i++) {
			for (int j = 0; j < col_count; j++) {
				//ͼĸǵк
				double dY[1] = { i + max_rows_ids };
				double dX[1] = { j };
				double dZ[1] = { dem(i,j)};
				int nSuccess[1] = { FALSE };
				GDALRPCTransform(pRPCTransform, FALSE, 1, dX, dY, dZ, nSuccess);
				lon(i, j) = dX[0];
				lat(i, j) = dY[0];
			}
		}

		//qDebug() << "for time " << getCurrentTimeString() ;
		// д뵽ļ
		omp_set_lock(&lock); //û
		qDebug() << lon.array().minCoeff() ;
		lon_lat_img.saveImage(lon, max_rows_ids, 0, 1);
		lon_lat_img.saveImage(lat, max_rows_ids, 0, 2);
		count_lines = count_lines + line_invert;
		qDebug() << "rows:\t" << max_rows_ids << "\t-\t" << max_rows_ids + line_invert << "\t" << count_lines << "/" << lon_lat_img.height << "\t computing.....\t" << getCurrentTimeString() ;
		omp_unset_lock(&lock); //ͷŻ
	}
	omp_destroy_lock(&lock); //ٻ
	//ͷԴ
	GDALDestroyRPCTransformer(pRPCTransform);
	CSLDestroy(papszTransOption);
}

 
/// <summary>
/// DEMSAR_rc
/// </summary>
/// <param name="dem_path"></param>
/// <param name="sim_rc_path"></param>
/// <param name="PSTN"></param>
/// <returns></returns>


double getRangeColumn(long double R, long double NearRange, long double Fs, long double lamda)
{
	double result = (double)(2 * (R - NearRange) / lamda * Fs);
	return result;
}

Eigen::MatrixXd getRangeColumn(Eigen::MatrixXd R, long double NearRange, long double Fs, long double lamda)
{
	return ((R.array() - NearRange).array() / lamda * Fs).array().cast<double>();
}

double getRangebyColumn(double j, long double NearRange, long double Fs, long double lamda)
{
	return (j *  lamda / 2) /  Fs + NearRange;
 
}

Eigen::MatrixXd getRangebyColumn(Eigen::MatrixXd j, long double NearRange, long double Fs, long double lamda)
{
	return ((j.array() * lamda / 2) / Fs + NearRange).array().cast<double>();
}

 

double getIncAngle(Landpoint& satepoint, Landpoint& landpoint) {

	Landpoint Rsc = satepoint - landpoint; // AB=B-A
	Landpoint Rs = landpoint;// landpoint;
	double angle = getAngle(Rsc, Rs);
	if (angle >= 180) {
		return 360 - angle;
	}
	else {
		return angle;
	}
}




////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////    ASF                    ///////////////////////////////////////////////////
////// غϳɿ׾״ӰУо  ¶ѧ  /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////

/// <summary>
///  任 ϵ-> ECR
/// </summary>
/// <param name="sataspace">[x,y,z,vx,vy,vz]   nx6 </param>
/// <returns></returns>
Eigen::MatrixXd ASFOrthClass::Satellite2ECR(Eigen::Vector3d Rsc, Eigen::Vector3d Vsc)
{

	Eigen::Vector3d x, y, z;

	Eigen::MatrixXd M(3, 3);

	z = Rsc / Rsc.norm();
	y = Rsc.cross(Vsc) / (Rsc.norm() * Vsc.norm());
	x = y.cross(z);

	M.col(0) = x;
	M.col(1) = y;
	M.col(2) = z;
	return M;
}
/// <summary>
/// ȡָĿĵλʸ
/// </summary>
/// <param name="alpha">ֵ</param>
/// <param name="beta">ֵ</param>
/// <param name="M">任</param>
/// <returns></returns>
Eigen::Vector3d ASFOrthClass::UnitVectorOfSatelliteAndTarget(double alpha, double beta, Eigen::MatrixXd M)
{
	// ĿTĵλ ST = R * M * P
	Eigen::Vector3d P(sin(alpha), -1.0 * cos(alpha) * sin(beta), -1.0 * cos(alpha) * cos(beta));
	return  M * P;
}

/// <summary>
/// 
/// </summary>
/// <param name="R"></param>
/// <param name="alpha"></param>
/// <param name="beta"></param>
/// <param name="SatellitePosition"></param>
/// <param name="SatelliteVelocity"></param>
/// <param name="R_threshold"></param>
/// <param name="H"></param>
/// <returns></returns>
double ASFOrthClass::GetLookFromRangeYaw(double R, double alpha, double beta, Eigen::Vector3d SatellitePosition, Eigen::Vector3d SatelliteVelocity, double R_threshold, double H)
{
	/**
		Ralpha beta
		ݲοģʽ3 - 13ɴ˷עǽƷ
		args :
		Rб
			alpha : ״ӽ
			beta0 : betaʼֵ
			SatellitePosition : 3x1 ǿռλ
			TargetPosition3x1 Ŀ
	*/
	Eigen::MatrixXd M = this->Satellite2ECR(SatellitePosition, SatelliteVelocity);
	// 뾶
	double Rp = earth_Rp + H;
	double Rs_norm = SatellitePosition.norm();
	// ʼbeta
	if (beta == 0) {
		double beta_cos = (Rs_norm * Rs_norm + R * R - Rp * Rp) / (2 * Rs_norm * R);
		beta = acos(beta_cos);
	}

	double  delta_R, sin_eta, delta_beta, tan_eta;
	// 
	int i = 0;
	do {
		// бʵ
		delta_R = R - this->FR(alpha, beta, SatellitePosition, M, R_threshold, H);
		// 
		sin_eta = Rs_norm * sin(beta) / Rp;
		tan_eta = sin_eta / sqrt(1 - sin_eta * sin_eta);
		// 
		delta_beta = delta_R / (R * tan_eta);
		// 
		beta = beta + delta_beta;
		// жѭֹ
		i = i + 1;
		if (i >= 10000) // ﵽֹ
		{
			return -9999;
		}
	} while (abs(delta_R) > 0.01);
	return beta;
}

/// <summary>
/// betaalphaȡȡĿĿռλ
/// </summary>
/// <param name="alpha"></param>
/// <param name="beta"></param>
/// <param name="SatellitePosition"></param>
/// <param name="R"></param>
/// <param name="M"></param>
/// <returns></returns>
Eigen::Vector3d ASFOrthClass::GetXYZByBetaAlpha(double alpha, double beta, Eigen::Vector3d SatellitePosition, double R, Eigen::MatrixXd M)
{
	return SatellitePosition + R * this->UnitVectorOfSatelliteAndTarget(alpha, beta, M);
}

/// <summary>
/// FD
/// </summary>
/// <param name="alpha"></param>
/// <param name="beta"></param>
/// <param name="SatelliteVelocity"></param>
/// <param name="TargetVelocity"></param>
/// <param name="R"></param>
/// <param name="lamda"></param>
/// <param name="M"></param>
/// <returns></returns>
double ASFOrthClass::FD(double alpha, double beta, Eigen::Vector3d SatelliteVelocity, Eigen::Vector3d TargetVelocity, double R, double lamda, Eigen::MatrixXd M)
{
	/**
		beta, alpha, ǿռλ, б࣬ת
	*/
	Eigen::Vector3d UnitVector = this->UnitVectorOfSatelliteAndTarget(alpha, beta, M);
	Eigen::Vector3d Rst = -1 * R * UnitVector;
	double	Rst_Vst = Rst.dot(SatelliteVelocity - TargetVelocity);
	return -2 / (R * lamda) * Rst_Vst;
}


/// <summary>
/// FR
/// </summary>
/// <param name="alpha"></param>
/// <param name="beta"></param>
/// <param name="SatellitePosition"></param>
/// <param name="M"></param>
/// <param name="R_threshold"></param>
/// <param name="H"></param>
/// <returns></returns>
double ASFOrthClass::FR(double alpha, double beta, Eigen::Vector3d SatellitePosition, Eigen::MatrixXd M, double R_threshold, double H)
{
	/*
	 ״ӽǣ״ӽǣλãϵ任󣬴ظߵȲݲοйʽ3 - 1 == 3 - 10ļ̣ƴ˷
	args :
		alpha:״ӽ ٶ˶µģƵƵĽ
		beta : ״ӽ
		Satellite_position : ǿռλ
		Mϵת
		Hظ
	return :
		Rб
	*/
	//qDebug() << beta ;
	Eigen::Vector3d UnitVector = R_threshold * this->UnitVectorOfSatelliteAndTarget(alpha, beta, M);
	// ⷽ 3 - 10 Aʽ
	double a = (earth_Re + H) * (earth_Re + H);
	double b = earth_Rp * earth_Rp;
	long double Xs = SatellitePosition(0);
	long double Ys = SatellitePosition(1);
	long double Zs = SatellitePosition(2);
	long double Xp = UnitVector(0);
	long double Yp = UnitVector(1);
	long double Zp = UnitVector(2);
	//qDebug() << Xp<<"\t"<< Yp<<"\t"<< Zp ;
	long double A = (Xp * Xp + Yp * Yp) / a + (Zp * Zp) / b;
	long double B = 2 * (Xs * Xp + Ys * Yp) / a + 2 * Zs * Zp / b;
	long double C = (Xs * Xs + Ys * Ys) / a + Zs * Zs / b - 1;
	//qDebug() << A << "\t" << B << "\t" << C ;
	C = B * B - 4 * A * C;
	//qDebug() << A << "\t" << B << "\t" << C ;
	double R1 = (-B - sqrt(C)) / (2 * A);
	//double R2 = (-B + sqrt(C)) / (2 * A);
	//qDebug() << R1 << "\t" << R2 ;
	if (R1 > 1) {
		return R1 * R_threshold;
	}
	else {
		return -9999;
		//return (-B + math.sqrt(t)) / (2 * A) # ͨηų
	}

}

/// <summary>
/// ASF
/// </summary>
/// <param name="R"></param>
/// <param name="SatellitePosition">Ǹ߶</param>
/// <param name="SatelliteVelocity">ٶ</param>
/// <param name="TargetPosition">ʼ</param>
/// <param name="PSTN"></param>
/// <param name="R_threshold"></param>
/// <param name="H">ʼ߳</param>
/// <param name="alpha0"></param>
/// <param name="beta0"></param>
/// <returns></returns>
Eigen::Vector3d ASFOrthClass::ASF(double R, Eigen::Vector3d SatellitePosition, Eigen::Vector3d SatelliteVelocity, Eigen::Vector3d TargetPosition, PSTNAlgorithm PSTN, double R_threshold, double H, double alpha0, double beta0)
{
	// ֲʼ
	double alpha = alpha0;
	double beta = beta0;
	double delta_alpha = 0;
	// ʽǸݡйϳɿ׾״ǹ̡Ʒ봦
	// P164 5.8.4 ղ
	double fd = PSTN.calNumericalDopplerValue(R);
	Eigen::MatrixXd	M = this->Satellite2ECR(SatellitePosition, SatelliteVelocity);
	double FD_, delta_fd;
	Eigen::Vector3d XYZ;
	int i = 0;// ͳƵ
	while (true) {
		Eigen::Vector3d	TargetVelocity = Eigen::Vector3d(-1 * earth_We * TargetPosition(1), earth_We * TargetPosition(0), 0);// ٶ, ֲڼʱĬΪ0
		beta = this->GetLookFromRangeYaw(R, alpha, beta, SatellitePosition, SatelliteVelocity, R_threshold, H);
		FD_ = this->FD(alpha, beta, SatelliteVelocity, TargetVelocity, R, PSTN.lamda, M);
		delta_fd = FD_ - fd;
		delta_alpha = -1 * delta_fd * PSTN.lamda / (2 * (SatelliteVelocity - TargetVelocity).norm());
		TargetPosition = this->GetXYZByBetaAlpha(alpha, beta, SatellitePosition, R, M);
		//cout << i << "\t" << delta_alpha * R << "\t" << delta_alpha<<"\t"<< (abs(delta_alpha * R) < 0.1)<<"\t"<< (abs(delta_alpha) < 0.001) ;
		if (abs(delta_alpha * R) < 0.1 || abs(delta_alpha) < 0.0003)
		{
			break;
		}
		alpha = alpha + delta_alpha;
		i = i + 1;
		if (i > 10000) {
			throw new exception("ASF ʧ");
		}

	}
	return TargetPosition;
}

